Dim DEBUG
DEBUG = False

Set FSO = CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")

' read parameters
BFPath = WScript.Arguments(0) ' path to bogofilter.exe
KKey = WScript.Arguments(1) '  -s, -S, -n, -N
File = WScript.Arguments(2) ' file for testing
DBPath = WScript.Arguments(3) ' path to wordlist.db
If DEBUG Then
	DebugOutput "DEBUG: " & "BFPath=" & BFPath
	DebugOutput "DEBUG: " & "KKey=" & KKey
	DebugOutput "DEBUG: " & "File=" & File
	DebugOutput "DEBUG: " & "DBPath=" & DBPath
End If

' initialize variables
UDB = FSO.BuildPath(DBPath, "wordlist.db")
RDB = FSO.BuildPath(WshShell.RegRead("HKLM\SOFTWARE\AfterLogic\XMail\MAIL_ROOT"), ".SpamDB\wordlist.db")
File_size = 0
If DEBUG Then
	DebugOutput "DEBUG: " & "UDB=" & UDB
	DebugOutput "DEBUG: " & "RDB=" & RDB
End If

ExitCode=7

' check user spam folder existing
If FSO.FolderExists(DBPath) Then
	DebugOutput Date & " '" & DBPath & "' exists, going to learn spamfilter..."
Else
	DebugOutput Date & " '" & DBPath & "' unexists, creating folder to keep it..."
	FSO.CreateFolder(DBPath)
End If

' check user database file existing
If FSO.FileExists(UDB) Then
	DebugOutput Date & " '" & UDB & "' exists..."
Else
	DebugOutput Date & " '" & UDB & "' unexists, copy global..."
	FSO.CopyFile RDB, UDB
End If

KHFlag=""
If UDB = RDB Then
	KHFlag="-H"
End If
If DEBUG Then
	DebugOutput "DEBUG: " & "KHFlag=" & KHFlag
End If

' run bogofilter
If FSO.FileExists(File) Then
	DebugOutput Date & " '" & File & "' exists, going to learn spamfilter..."
	
	Set objFile = FSO.GetFile(File)
	File_size = objFile.Size
	
	WshShell.Run BFPath & " -e " & KKey & " " & KHFlag & " -I """ & File & """ -d """ & DBPath & """", 0, True
	
	DebugOutput "RUN: " & BFPath & " -e " & KKey & " " & KHFlag & " -I """ & File & """ -d """ & DBPath & """"
	DebugOutput Date & "Filter:" & BFPath _
		& "	Key:" & KKey _
		& "	File:" & File _
		& "	Size:" & File_size _
		& "	Database:" & DBPath
	DebugOutput Date & " Spamfilter actualized and learned..."
	ExitCode = 16
Else
	DebugOutput Date & " '" & File & "' unexists, going to exit..."
	ExitCode = 16
End If

WScript.Quit(ExitCode)

Sub DebugOutput(str)
	If DEBUG Then
		Set writeStream = FSO.OpenTextFile("spamfilter-learn-DEBUG-" & Date & ".log", 8, True, -2)
		writeStream.WriteLine(str)
		writeStream.Close()
	End If
	WScript.Echo str
End Sub
