<?php

/*
 * AfterLogic Admin Panel by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 * 
 */

	class CXmail_Plugin extends ap_Plugin
	{
		/**
		 * @var	Xmail_Settings
		 */
		var $_settings;
		
		var $_wmserver;		

		/**
		 * @var	bool
		 */
		var $_isConnect = false;
		
		/**
		 * @var	array
		 */
		var $Tabs = array(
			array('Server', 'Xmail Settings', 'xmail'), 
			array('Domains', 'Xmail Domains', 'domains'),
			array('Users', 'Xmail Users', 'users')
		);
		
		/**
		 * @var	bool
		 */
		var $HasGlobal = true;
		
		/**
		 * @param	string	$tab
		 * @return	string|false
		 */
		function GetScreenName($tab)
		{
			$return = false;
			switch ($tab)
			{
				case 'xmail':
					$return = 'ap_Screen_Standard';
					break;
				case 'users':
				case 'domains':
					$return = 'ap_Screen_Tables';
					break;
			}
			
			return $return;
		}
		
		/**
		 * @return	string
		 */
		function WriteAction()
		{
			$ref = null;
			$errorDesc = '';
			$infoDesc = '';
			
			$this->_initSession();
			
			if (isset($_POST['form_id']) && strlen($_POST['form_id']) > 0)
			{
				if (!$this->Connect())
				{
					$errorDesc = ap_Utils::TakePhrase('XM_CANTCONNECT');
				}
				else
				{
					$saveSettings = true;
					$tc = new Xmail_TabConfig();
					$tabs = $this->_wmserver->GetTabFile('server.tab');
					foreach ($tabs as $line)
					{
						$tc->AddLine(new Xmail_TabConfigLine($line));
					}
					
					switch ($_POST['form_id'])
					{
						default:
							$saveSettings = false;
							$errorDesc = ap_Utils::TakePhrase('XM_INFO_SAVEUNSUCCESSFUL');
							break;
						case 'smtp':
							if (isset($_POST['box_SmtpProto']) && $_POST['box_SmtpProto'] == '1')
							{
								$tc->SetBoolValueByKey('SmtpProto', true);
								$tc->SetValueByKey('SmtpPort', (isset($_POST['var_SmtpPort'])) ? (int) $_POST['var_SmtpPort'] : null);
								$tc->SetValueByKey('SmtpPortSSL', (isset($_POST['var_SmtpPortSSL'])) ? (int) $_POST['var_SmtpPortSSL'] : null);
								
								$tc->SetBoolValueByKey('EnableSMTP-TLS', (isset($_POST['box_EnableSMTP_TLS']) && $_POST['box_EnableSMTP_TLS'] == '1'));
								$tc->SetBoolValueByKey('EnableAuthSMTP-POP3', (isset($_POST['box_EnableAuthSMTP_POP3']) && $_POST['box_EnableAuthSMTP_POP3'] == '1'));
								
								if (isset($_POST['check_SmtpGwConfig']) && $_POST['check_SmtpGwConfig'] == '1')
								{
									if (isset($_POST['SmtpGlobalGatewayOptionsName']))
									{
										if ($_POST['SmtpGlobalGatewayOptionsName'] == 'SmtpGlobalGatewayOptionsCustomRadioID')
										{
											$tc->SetValueByKey('SmtpGwConfig', (isset($_POST['var_SmtpGwConfig'])) ? $_POST['var_SmtpGwConfig'] : null);
										}
										else
										{
											$tc->SetValueByKey('SmtpGwConfig', 'NeedTLS=1,OutBind=192.168.1.1');
										}
									}
								}
								else
								{
									$tc->SetIsComment('SmtpGwConfig', true);
								}
								
								if (isset($_POST['check_DefaultSMTPGateways']) && $_POST['check_DefaultSMTPGateways'] == '1')
								{
									if (isset($_POST['DefaultSmtpGatewayListName']))
									{
										if ($_POST['DefaultSmtpGatewayListName'] == 'DefaultSmtpGatewayListCustomRadioID')
										{
											$tc->SetValueByKey('DefaultSMTPGateways', (isset($_POST['var_DefaultSMTPGateways'])) ? $_POST['var_DefaultSMTPGateways'] : null);
										}
										else
										{
											$tc->SetValueByKey('DefaultSMTPGateways', '192.168.1.2,192.168.1.15');
										}
									}
								}
								else
								{
									$tc->SetIsComment('DefaultSMTPGateways', true);
								}
		
								if (isset($_POST['check_SmtpConfig']) && $_POST['check_SmtpConfig'] == '1')
								{
									if (isset($_POST['SmtpAuthName']))
									{
										if ($_POST['SmtpAuthName'] == 'SmtpAuthCustomRadioID')
										{
											$tc->SetValueByKey('SmtpConfig', (isset($_POST['var_SmtpConfig'])) ? $_POST['var_SmtpConfig'] : null);
										}
										else
										{
											$tc->SetValueByKey('SmtpConfig', 'mail-auth');
										}
									}
								}
								else
								{
									$tc->SetIsComment('SmtpConfig', true);
								}								
								
								$tc->SetValueByKey('DefaultSmtpPerms', (isset($_POST['var_DefaultSmtpPerms'])) ? $_POST['var_DefaultSmtpPerms'] : null);
								
								$tc->SetBoolValueByKey('AllowSmtpVRFY', (isset($_POST['box_AllowSmtpVRFY']) && $_POST['box_AllowSmtpVRFY'] == '1'));
								
								if ((isset($_POST['check_MaxMessageSize']) && $_POST['check_MaxMessageSize'] == '1'))
								{
									$tc->SetValueByKey('MaxMessageSize', (isset($_POST['var_MaxMessageSize'])) ? $_POST['var_MaxMessageSize'] : null);
								}
								else
								{
									$tc->SetIsComment('MaxMessageSize', true);
								}
							}
							else
							{
								$tc->SetBoolValueByKey('SmtpProto', false);
							}
							
							$ref = '?mode=smtp';
							break;
						
						case 'pop3':
							$tc->SetBoolValueByKey('Pop3Proto', (isset($_POST['box_Pop3Proto']) && $_POST['box_Pop3Proto'] == '1'));
							$tc->SetValueByKey('Pop3Port', (isset($_POST['var_Pop3Port'])) ? (int) $_POST['var_Pop3Port'] : null);
							$tc->SetValueByKey('Pop3PortSSL', (isset($_POST['var_Pop3PortSSL'])) ? (int) $_POST['var_Pop3PortSSL'] : null);
							$tc->SetBoolValueByKey('EnablePOP3-TLS', (isset($_POST['box_EnablePOP3_TLS']) && $_POST['box_EnablePOP3_TLS'] == '1'));
		
							$ref = '?mode=pop3';
							break;
							
						case 'imap4':
							$tc->SetBoolValueByKey('Imap4Proto', (isset($_POST['box_Imap4Proto']) && $_POST['box_Imap4Proto'] == '1'));
							$tc->SetValueByKey('Imap4Port', (isset($_POST['var_Imap4Port'])) ? (int) $_POST['var_Imap4Port'] : null);
							$tc->SetValueByKey('Imap4PortSSL', (isset($_POST['var_Imap4PortSSL'])) ? (int) $_POST['var_Imap4PortSSL'] : null);
		
							$ref = '?mode=imap4';
							break;
							
						case 'domains':
							$tc->SetValueByKey('RootDomain', (isset($_POST['var_RootDomain'])) ? $_POST['var_RootDomain'] : null);
							if (isset($_POST['check_HeloDomain']) && $_POST['check_HeloDomain'] == '1')
							{
								$tc->SetValueByKey('HeloDomain', (isset($_POST['var_HeloDomain'])) ? $_POST['var_HeloDomain'] : null);
							}
							else
							{
								$tc->SetIsComment('HeloDomain', true);
							}
							if (isset($_POST['check_SmtpServerDomain']) && $_POST['check_SmtpServerDomain'] == '1')
							{
								$tc->SetValueByKey('SmtpServerDomain', (isset($_POST['var_SmtpServerDomain'])) ? $_POST['var_SmtpServerDomain'] : null);
							}
							else
							{
								$tc->SetIsComment('SmtpServerDomain', true);
							}
							if (isset($_POST['check_POP3Domain']) && $_POST['check_POP3Domain'] == '1')
							{
								$tc->SetValueByKey('POP3Domain', (isset($_POST['var_POP3Domain'])) ? $_POST['var_POP3Domain'] : null);
							}
							else
							{
								$tc->SetIsComment('POP3Domain', true);
							}
							$ref = '?mode=domains';
							break;
							
						case 'errors':
							$tc->SetValueByKey('ErrorsAdmin', (isset($_POST['var_ErrorsAdmin'])) ? $_POST['var_ErrorsAdmin'] : null);
							$tc->SetValueByKey('TempErrorsAdmin', (isset($_POST['var_TempErrorsAdmin'])) ? $_POST['var_TempErrorsAdmin'] : null);
							$tc->SetValueByKey('NotifyMsgLinesExtra', (isset($_POST['var_NotifyMsgLinesExtra'])) ? (int) $_POST['var_NotifyMsgLinesExtra'] : null);
							$tc->SetBoolValueByKey('NotifySendLogToSender', (isset($_POST['box_NotifySendLogToSender']) && $_POST['box_NotifySendLogToSender'] == '1'));
							$tc->SetValueByKey('SMTP-MaxErrors', (isset($_POST['var_SMTP_MaxErrors'])) ? (int) $_POST['var_SMTP_MaxErrors'] : null);
		
							if (isset($_POST['check_CustomSMTPMessage']) && $_POST['check_CustomSMTPMessage'] == '1')
							{
								$tc->SetValueByKey('CustomSMTPMessage', (isset($_POST['var_CustomSMTPMessage'])) ? $_POST['var_CustomSMTPMessage'] : null);
							}
							else
							{
								$tc->SetIsComment('CustomSMTPMessage', true);
							}
							
							if (isset($_POST['check_CustMapsList']) && $_POST['check_CustMapsList'] == '1')
							{
								if (isset($_POST['CustMapsListName']))
								{
									if ($_POST['CustMapsListName'] == 'custom')
									{
										$tc->SetValueByKey('CustMapsList', (isset($_POST['var_CustMapsList'])) ? $_POST['var_CustMapsList'] : null);
									}
									else
									{
										$tc->SetValueByKey('CustMapsList', 'list.dsbl.org.:1,blackholes.mail-abuse.org.:1,dialups.mail-abuse.org.:0');
									}
								}
							}
							else
							{
								$tc->SetIsComment('CustMapsList', true);
							}
							
							if (isset($_POST['check_NotifyTryPattern']) && $_POST['check_NotifyTryPattern'] == '1')
							{
								$tc->SetValueByKey('NotifyTryPattern', (isset($_POST['var_NotifyTryPattern'])) ? $_POST['var_NotifyTryPattern'] : null);
							}
							else
							{
								$tc->SetIsComment('NotifyTryPattern', true);
							}
		
							if (isset($_POST['check_Pop3SyncErrorAccount']) && $_POST['check_Pop3SyncErrorAccount'] == '1')
							{
								$tc->SetValueByKey('Pop3SyncErrorAccount', (isset($_POST['var_Pop3SyncErrorAccount'])) ? $_POST['var_Pop3SyncErrorAccount'] : null);
							}
							else
							{
								$tc->SetIsComment('Pop3SyncErrorAccount', true);
							}
							
							$tc->SetBoolValueByKey('RemoveSpoolErrors', (isset($_POST['box_RemoveSpoolErrors']) && $_POST['box_RemoveSpoolErrors'] == '1'));
							
							$ref = '?mode=errors';
							break;
							
						case 'spam':
							$tc->SetBoolValueByKey('AllowNullSender', (isset($_POST['box_AllowNullSender']) && $_POST['box_AllowNullSender'] == '1'));
							$tc->SetBoolValueByKey('CheckMailerDomain', (isset($_POST['box_CheckMailerDomain']) && $_POST['box_CheckMailerDomain'] == '1'));
							$tc->SetBoolValueByKey('SMTP-RDNSCheck', (isset($_POST['box_SMTP_RDNSCheck']) && $_POST['box_SMTP_RDNSCheck'] == '1'));
							$tc->SetValueByKey('SmtpMsgIPBanSpammers', (isset($_POST['var_SmtpMsgIPBanSpammers'])) ? $_POST['var_SmtpMsgIPBanSpammers'] : null);
							$this->_setBayesianAndVirusFilter(isset($_POST['box_BayesianCheck']), isset($_POST['box_AntivirusCheck']));
							
							$ref = '?mode=spam';
							break;
							
						case 'misc':
							if (isset($_POST['box_FingerProto']) && $_POST['box_FingerProto'] == '1')
							{
								$tc->SetBoolValueByKey('FingerProto', true);
								$tc->SetValueByKey('FingerPort', (isset($_POST['var_FingerPort'])) ? (int) $_POST['var_FingerPort'] : null);
							}
							else
							{
								$tc->SetBoolValueByKey('FingerProto', false);
							}
							$tc->SetValueByKey('MaxMTAOps', (isset($_POST['var_MaxMTAOps'])) ? (int) $_POST['var_MaxMTAOps'] : null);
							
							if (isset($_POST['SmartDnsHostName']))
							{
								if ($_POST['SmartDnsHostName'] == 'custom')
								{
									$tc->SetValueByKey('SmartDNSHost', (isset($_POST['var_SmartDNSHost'])) ? $_POST['var_SmartDNSHost'] : null);
								}
								else
								{
									$tc->SetValueByKey('SmartDNSHost', 'dns.home.bogus.net:tcp,192.168.1.1:udp');
								}
							}
							if (isset($_POST['check_SmtpMinDiskSpace']) && $_POST['check_SmtpMinDiskSpace'] == '1')
							{
								$tc->SetValueByKey('SmtpMinDiskSpace', (isset($_POST['var_SmtpMinDiskSpace'])) ? $_POST['var_SmtpMinDiskSpace'] : null);
							}
							else
							{
								$tc->SetIsComment('SmtpMinDiskSpace', true);
							}
							if (isset($_POST['check_SmtpMinVirtMemSpace']) && $_POST['check_SmtpMinVirtMemSpace'] == '1')
							{
								$tc->SetValueByKey('SmtpMinVirtMemSpace', (isset($_POST['var_SmtpMinVirtMemSpace'])) ? $_POST['var_SmtpMinVirtMemSpace'] : null);
							}
							else
							{
								$tc->SetIsComment('SmtpMinVirtMemSpace', true);
							}							
							if (isset($_POST['check_Pop3MinVirtMemSpace']) && $_POST['check_Pop3MinVirtMemSpace'] == '1')
							{
								$tc->SetValueByKey('Pop3MinVirtMemSpace', (isset($_POST['var_Pop3MinVirtMemSpace'])) ? $_POST['var_Pop3MinVirtMemSpace'] : null);
							}
							else
							{
								$tc->SetIsComment('Pop3MinVirtMemSpace', true);
							}

							$tc->SetBoolValueByKey('DisableEmitAuthUser', (isset($_POST['box_DisableEmitAuthUser']) && $_POST['box_DisableEmitAuthUser'] == '1'));
							if (isset($_POST['check_ReceivedHdrType']) && $_POST['check_ReceivedHdrType'] == '1')
							{
								if (isset($_POST['var_ReceivedHdrType']))
								{
									$tc->SetValueByKey('ReceivedHdrType', (int) $_POST['var_ReceivedHdrType']);
								}
							}
							else
							{
								$tc->SetIsComment('ReceivedHdrType', true);
							}
							$ref = '?mode=misc';
							break;
							
						case 'log':
							$tc->SetBoolValueByKey('LogGLOBAL', (isset($_POST['box_LogSystem']) && $_POST['box_LogSystem'] == '1'));
							$tc->SetBoolValueByKey('LogSMTP', (isset($_POST['box_LogSMTP']) && $_POST['box_LogSMTP'] == '1'));
							$tc->SetBoolValueByKey('LogPOP3', (isset($_POST['box_LogPOP3']) && $_POST['box_LogPOP3'] == '1'));
							$tc->SetBoolValueByKey('Pop3LogPasswd', (isset($_POST['box_Pop3LogPasswd']) && $_POST['box_Pop3LogPasswd'] == '1'));
							$tc->SetBoolValueByKey('LogIMAP4', (isset($_POST['box_LogIMAP4']) && $_POST['box_LogIMAP4'] == '1'));
							$tc->SetBoolValueByKey('LogCTRL', (isset($_POST['box_LogCTRL']) && $_POST['box_LogCTRL'] == '1'));
							$tc->SetBoolValueByKey('LogLMAIL', (isset($_POST['box_LogLMAIL']) && $_POST['box_LogLMAIL'] == '1'));
							$tc->SetBoolValueByKey('LogSMAIL', (isset($_POST['box_LogSMAIL']) && $_POST['box_LogSMAIL'] == '1'));
		
							$ref = '?mode=log';
							break;
							
						case 'admin':
							$tc->SetValueByKey('User', (isset($_POST['var_User'])) ? $_POST['var_User'] : null);
							$tc->SetValueByKey('Group', (isset($_POST['var_Group'])) ? $_POST['var_Group'] : null);
							$tc->SetValueByKey('PostMaster', (isset($_POST['var_PostMaster'])) ? $_POST['var_PostMaster'] : null);
							$tc->SetBoolValueByKey('ControlProto', (isset($_POST['box_ControlProto']) && $_POST['box_ControlProto'] == '1'));
							$tc->SetValueByKey('ControlPort', (isset($_POST['var_ControlPort'])) ? $_POST['var_ControlPort'] : null);
							$tc->SetValueByKey('ControlPortSSL', (isset($_POST['var_ControlPortSSL'])) ? $_POST['var_ControlPortSSL'] : null);							
							$tc->SetBoolValueByKey('EnableCTRL-TLS', (isset($_POST['box_EnableCTRL_TLS']) && $_POST['box_EnableCTRL_TLS'] == '1'));
							
							$ref = '?mode=admin';
							break;
					}
					
					if ($saveSettings)
					{
						if ($this->_wmserver->SetTabFile('server.tab', $tc->ToArray()))
						{
							if ($_POST['form_id'] == 'admin')
							{
								if (!$this->_saveDisplayAdvancedData(isset($_POST['ch_DisplayAdvanced'])))
								{
									$errorDesc = strlen($errorDesc) > 0 ? $errorDesc : ap_Utils::TakePhrase('FILE_ERROR_OCCURRED');	
								}
							}
							
							$infoDesc = strlen($infoDesc) > 0 ? $infoDesc : ap_Utils::TakePhrase('XM_INFO_SAVESUCCESSFUL');
						}
						else
						{
							$errorDesc = strlen($errorDesc) > 0 ? $errorDesc : ap_Utils::TakePhrase('XM_INFO_SAVEUNSUCCESSFUL');
						}
					}
				}
			}
			else if (isset($_POST['mode_name']) && strlen($_POST['mode_name']) > 0)
			{
				if ($this->Connect())
				{
					if ($this->_ap->Tab() == 'domains')
					{
						switch ($_POST['mode_name'])
						{
							case 'collection':
								if (isset($_POST['chCollection']) && count($_POST['chCollection']) > 0)
								{
									$result = true;
									foreach ($_POST['chCollection'] as $coll)
									{
										$expl = explode(AP_UIDS_DELIMITER, $coll);
										
										foreach ($expl as $domain)
										{
											$arr = ap_Utils::UidExplode($domain);
											if ($arr[0] == AP_TYPE_XMAIL)
											{
												$result &= $this->_wmserver->DeleteDomain(strtolower($arr[1]));
												
											}
											else if ($arr[0] == AP_TYPE_XMAIL_CUSTOM)
											{
												$result &= $this->_wmserver->DeleteCustomDomain(strtolower($arr[1]));
											}
										}
									}
									if ($result)
									{
										$infoDesc = ap_Utils::TakePhrase('XM_DELETE_SUCCESSFUL');
									}
									else
									{
										$errorDesc = $this->_wmserver->GetClearError();
									}
								}
								break;
								
							case 'new':
								
								if (isset($_POST['switchElement']))
								{
									switch ($_POST['switchElement'])
									{
										case 'int':
											if (isset($_POST['textDomainName']) && strlen($_POST['textDomainName']) > 0)
											{
												include $this->PluginPath().'/common/class_domains.php';
													
												$domain = new CXMailDomain();
												$domain->_name = strtolower($_POST['textDomainName']);
												
												$domain->SetSessionArray();
												
												if ($this->_wmserver->DomainExist($domain->_name))
												{
													$ref = '?mode=new&type='.urlencode($_POST['switchElement']);
													$errorDesc = ap_Utils::TakePhrase('XM_DOMAIN_EXIST');
												}
												else
												{
													if ($this->_wmserver->AddDomain($domain->_name))
													{
														$infoDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATESUCCESSFUL');
														$domain->ClearSessionArray();
														$GLOBALS[AP_GLOBAL_USERFILTER_HREFS][] = AP_TYPE_XMAIL.AP_TYPE_DELIMITER.$domain->_name;
													}
													else
													{
														$ref = '?mode=new&type='.urlencode($_POST['switchElement']);
														$errorDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATEUNSUCCESSFUL');
													}
												}
											}
											break;
											
										case 'forw':
											
											if (isset($_POST['textDomainName']) && strlen($_POST['textDomainName']) > 0)
											{
												include $this->PluginPath().'/common/class_domains.php';
												
												$domain = new CXMailDomain();
												$domain->_name = strtolower($_POST['textDomainName']);

												if (isset($_POST['LRedirectionsListDDL']) && is_array($_POST['LRedirectionsListDDL']) && count($_POST['LRedirectionsListDDL']) > 0)
												{
													$domain->_act_forwards = $_POST['LRedirectionsListDDL'];
												}
												if (isset($_POST['AdvancedID']) && strlen($_POST['AdvancedID']) > 0)
												{
													$domain->_customDomainProcessing = $_POST['AdvancedID'];						
												}
												
												$domain->SetSessionArray();
												
												if ($this->_wmserver->CustomDomainExist($domain->_name))
												{
													$ref = '?mode=new&type='.urlencode($_POST['switchElement']);
													$errorDesc = ap_Utils::TakePhrase('XM_DOMAIN_EXIST');
												}
												else
												{
													$arr = $domain->ToDataArray();
													$result = (count($arr) > 0)
														? $this->_wmserver->SetMailProc($domain->_name, '', $arr)
														: $this->_wmserver->AddCustomDomain($domain->_name);
														
													if ($result)
													{
														$infoDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATESUCCESSFUL');
														$domain->ClearSessionArray();
													}
													else
													{
														$ref = '?mode=new&type='.urlencode($_POST['switchElement']);
														$errorDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATEUNSUCCESSFUL');
													}	
												}
											}
											break;
									}
								}
								break;
								
							case 'edit':
								if (isset($_POST['uid']) && strlen($_POST['uid']) > 4 && substr($_POST['uid'], 0, 3) == AP_TYPE_XMAIL_CUSTOM)
								{
									$domainName = substr($_POST['uid'], 4);
									
									include $this->PluginPath().'/common/class_domains.php';
												
									$domain = new CXMailDomain();
									$domain->_name = $domainName;
									if (isset($_POST['LRedirectionsListDDL']) && is_array($_POST['LRedirectionsListDDL']) && count($_POST['LRedirectionsListDDL']) > 0)
									{
										$domain->_act_forwards = $_POST['LRedirectionsListDDL'];
									}
									if (isset($_POST['AdvancedID']) && strlen($_POST['AdvancedID']) > 0)
									{
										$domain->_customDomainProcessing = $_POST['AdvancedID'];						
									}
									
									$domain->SetSessionArray();
									
									if ($this->_wmserver->CustomDomainExist($domain->_name))
									{
										$arr = $domain->ToDataArray();
										if ($this->_wmserver->SetMailProc($domain->_name, '', $arr))
										{
											$infoDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATESUCCESSFUL');
											$domain->ClearSessionArray();
										}
										else
										{
											$ref = '?mode=edit&type='.urlencode($_POST['uid']);
											$errorDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATEUNSUCCESSFUL');
										}
									}
									else
									{
										$ref = '?mode=edit&type='.urlencode($_POST['uid']);
										$errorDesc = ap_Utils::TakePhrase('XM_DOMAIN_CREATEUNSUCCESSFUL');
									}
								}
								break;

						} /* switch ($_POST['mode_name']) */
					} /* if ($this->_ap->Tab() == 'domains') */
					else if ($this->_ap->Tab() == 'users')
					{
						$domainName = '';
						if (isset($_SESSION[AP_SESS_FILTER]) && strlen($_SESSION[AP_SESS_FILTER]) > 0)
						{
							$resp = $this->_thisIsMyUid($_SESSION[AP_SESS_FILTER]);
							if ($resp !== false)
							{
								$arr = ap_Utils::UidExplode($resp);
								if (strlen($arr[0]) > 0)
								{
									$domainName = $arr[1];
								}
							}
						}
						
						if (strlen($domainName) > 0)
						{
							switch ($_POST['mode_name'])
							{
								case 'collection':
									
									if (isset($_POST['chCollection']) && count($_POST['chCollection']) > 0)
									{
										$result = true;
										foreach ($_POST['chCollection'] as $coll)
										{
											$expl = explode(AP_UIDS_DELIMITER, $coll);
											foreach ($expl as $domain)
											{
												$arr = ap_Utils::UidExplode($domain);
												if ($arr[0] == AP_TYPE_XMAIL)
												{
													$result &= $this->_wmserver->DeleteUser($domainName, $arr[1]);
												}
											}
										}
										if ($result)
										{
											$infoDesc = ap_Utils::TakePhrase('XM_DELETE_SUCCESSFUL');
										}
										else
										{
											$errorDesc = $this->_wmserver->GetClearError();
										}
									}
									break;
									
								case 'new':	
	
									$type = (isset($_POST['userType'])) ? $_POST['userType'] : null;
									if ($type == 'new')
									{
										$userLogin = isset($_POST['txtXmailLogin']) ? trim($_POST['txtXmailLogin']) : '';
										$userPassword = isset($_POST['txtXmailPassword']) ? trim($_POST['txtXmailPassword']) : '';
										
										include $this->PluginPath().'/common/class_user_mini.php';
											
										$UserMini = new CXMailUserMini();
										$UserMini->_login = $userLogin;
										$UserMini->SetSessionArray();
										
										if (strlen($userLogin) > 0 && strlen($userPassword) > 0)
										{
											if($this->_wmserver->UserExist($domainName, $UserMini->_login))
											{
												$errorDesc = ap_Utils::TakePhrase('XM_USER_EXIST');
											}
											else if ($this->_wmserver->AddUser($domainName, $UserMini->_login, $userPassword, 'U'))
											{
												$UserMini->ClearSessionArray();
												$infoDesc = ap_Utils::TakePhrase('XM_INFO_ACCOUNTADD');
											}
											else
											{
												$errorDesc = $this->_wmserver->GetClearError();
											}
										}
										else
										{
											$errorDesc = ap_Utils::TakePhrase('XM_ERROR_USERNAMEPASSWORDNULL');
										}
									}
									else if ($type == 'mlist')
									{
										$userLogin = isset($_POST['txtXmailLogin']) ? $_POST['txtXmailLogin'] : null;
										$userPassword = AP_DUMMYPASSWORD;
										
										include $this->PluginPath().'/common/class_user_mini.php';
										
										$UserMini = new CXMailUserMini();
										$UserMini->_login = $userLogin;
										$UserMini->SetSessionArray();
										
										if (strlen($userLogin) > 0)
										{
											if ($this->_wmserver->UserExist($domainName, $UserMini->_login))
											{
												$errorDesc = ap_Utils::TakePhrase('XM_USER_EXIST');
											}
											else if ($this->_wmserver->AddUser($domainName, $UserMini->_login, $userPassword, 'M'))
											{
												$UserMini->ClearSessionArray();
												$infoDesc = ap_Utils::TakePhrase('XM_INFO_MAILINGLISTADD');
											}
											else
											{
												$errorDesc = $this->_wmserver->GetClearError();
											}
										}
										else
										{
											$errorDesc = ap_Utils::TakePhrase('XM_ERROR_USERNAMENULL');
										}
									}
									
									if (strlen($errorDesc) > 0)
									{
										$ref = '?mode=new&type='.urlencode($type);
									}
									
									break;
															
								case 'edit':
									
									if (isset($_POST['uType']) && isset($_POST['uid']) && strlen($_POST['uid']) > 3)
									{
										include $this->PluginPath().'/common/class_user.php';
										
										$user = new CXMailUser();
										$this->_updateUserFromPost($user);
										
										$user->SetSessionArray();
										$result = true;
										
										if (!$this->_wmserver->UserExist($domainName, $user->_login))
										{
											$result = false;
											$errorDesc = ap_Utils::TakePhrase('XM_USER_DONTEXIST');
										}
										/*
										if ($result && isset($_POST['AliasActionID']) && $_POST['AliasActionID'] == 'add' && isset($_POST['AccountAliasID']))
										{
											if (!$this->_wmserver->AddAlias($domainName, $user->_login, $_POST['AccountAliasID']))
											{
												$errorDesc = $this->_wmserver->GetClearError();
												$result = false;
											}
											
											$user->ClearSessionArray();
											$start = isset($_POST['startID']) ? (int) $_POST['startID'] : 2;
											$ref = '?mode=edit&uid='.urlencode($_POST['uid']).'&start='.$start;
										}
										else if ($result && isset($_POST['AliasActionID']) && $_POST['AliasActionID'] == 'del')
										{
											if (isset($_POST['AliasesListDDL']) && is_array($_POST['AliasesListDDL']))
											{
												foreach ($_POST['AliasesListDDL'] as $delA)
												{
													$this->_wmserver->DeleteAlias($domainName, $delA);
												}
											}
											
											$user->ClearSessionArray();
											$start = isset($_POST['startID']) ? (int) $_POST['startID'] : 2;
											$ref = '?mode=edit&uid='.urlencode($_POST['uid']).'&start='.$start;
										} 
										else */if ($result && ($_POST['uType'] == 'mlist' || $_POST['uType'] == 'xmuser' || $_POST['uType'] == 'xmwmuser'))
										{
											$arr = $user->ToRedirectDataArray();
											if (!$this->_wmserver->SetMailProc($domainName, $user->_login, $arr))
											{
												$result = false;
											}
											
											/* alias */
											$arr = $user->GetAliasArray();
											$xmail_alias = $this->_wmserver->AliasList($domainName, '*', $user->_login);
											foreach ($xmail_alias as $key => $_tmp)
											{
												$xmail_alias[$key] = $_tmp[1];
											}
											
											$xmail2delete = array_diff($xmail_alias, $arr);
											$xmail2add = array_diff($arr, $xmail_alias);
											
											foreach ($xmail2delete as $delA)
											{
												$this->_wmserver->DeleteAlias($domainName, $delA);
											}
										
											foreach ($xmail2add as $addA)
											{
												$this->_wmserver->AddAlias($domainName, $user->_login, $addA);
											}
											
											if ($result)
											{
												$nSize = $nPassword = null;
												
												if ($_POST['uType'] == 'xmuser' || $_POST['uType'] == 'xmwmuser')
												{
													$nSize = $user->_mailBoxSize;
													$nPassword = $user->_password;
													
													if (!$this->_wmserver->ChangeUserVarsNew($domainName, $user->_login, null, $nSize, null))
													{
														$result = false;
													}
													
													if ($result && strlen($nPassword) > 0 && $nPassword != AP_DUMMYPASSWORD)
													{
														if (!$this->_wmserver->ChangeUserPass($domainName, $user->_login, $nPassword))
														{
															$result = false;
														}
													}
												}

												if ($_POST['uType'] == 'mlist')
												{
													$serverMList = array();
													$tempServerMList = $this->_wmserver->MlUserList($domainName, $user->_login);
													foreach ($tempServerMList as $item)
													{
														if (count($item) == 2)
														{
															$temp = ($item[1] == 'R') ? 'RS' : $item[1];
															$serverMList[] = $temp.'|'.$item[0];
														} 
													}
													
													$addMemb = array_diff($user->_mlusers, $serverMList);
													$delMemb = array_diff($serverMList, $user->_mlusers);
													
													if (count($delMemb) > 0)
													{
														foreach ($delMemb as $item)
														{
															$adress = substr($item, 3);
															$this->_wmserver->DeleteMlUser($domainName, $user->_login, $adress);
														}
													}

													if (count($addMemb) > 0)
													{
														foreach ($addMemb as $item)
														{
															$perm = (substr($item, 0, 2) == 'RS') ? 'R' : 'RW';
															$adress = substr($item, 3);
															$this->_wmserver->AddMlUser($domainName, $user->_login, $adress, $perm);
														}
													}
												}
											}
										}
										
										if ($result)
										{
											$user->ClearSessionArray();
											$infoDesc = ap_Utils::TakePhrase('XM_INFO_SAVESUCCESSFUL');
											/*
											$temp_errorDesc = $this->_wmserver->GetClearError();
											if (strlen($temp_errorDesc) > 0)
											{
												$infoDesc = ap_Utils::TakePhrase('XM_INFO_SAVESUCCESSFUL').'<br />but '.$temp_errorDesc;
											}
											*/
										}
										else
										{
											$errorDesc = (strlen($errorDesc) == 0) ? ap_Utils::TakePhrase('XM_INFO_SAVEUNSUCCESSFUL') : $errorDesc;
										}
									}
										
									break;
							}
								
						} /* switch ($_POST['mode_name']) */
					} /* if ($this->_ap->Tab() == 'users') */
				}
				else
				{
					$errorDesc = ap_Utils::TakePhrase('XM_CANTCONNECT');
				}
			}

			if (strlen($errorDesc) > 0)
			{
				$this->_setError($errorDesc);
			}
			elseif(strlen($infoDesc) > 0)
			{
				$this->_setInfo($infoDesc);
			}
			
			@$this->Disconnect();
			
			return $ref;
		}
		
		function WritePop() 
		{
			$this->_initSession();
			
			$PosibleLogTypes = array(
							'xmail',
							'smtp',
							'pop3',
							'imap4',
							'ctrl',
							'lmail',
							'smail');
			
			$type = isset($_GET['type']) ? $_GET['type'] : 'null';
			switch ($type)
			{
				default:
					break;
				case 'log':
					$text = '';
					$cmd = isset($_GET['cmd']) ? $_GET['cmd'] : 'null';
					if (in_array($cmd, $PosibleLogTypes))
					{
						if ($this->Connect())
						{
							$logArray = $this->_wmserver->GetLog($cmd);
							if (is_array($logArray))
							{
								foreach ($logArray as $logLine)
								{
									$text .= $logLine.AP_CRLF;
								}
							}
							 $this->Disconnect();
						}
						else
						{
							$text = ap_Utils::TakePhrase('XM_CANTCONNECT');
						}
					}

					@header('Content-Type: text/plain');
					echo ($text) ? $text : '';
					break;
			}
		}
		
		/**
		 * @param	bool	$_isBSet
		 * @param	bool	$_isVSet
		 * @return	bool
		 */
		function _setBayesianAndVirusFilter($_isBSet, $_isVSet)
		{
			if ($this->Connect())
			{
				$_filterArray = $this->_wmserver->GetTabFile('filters.in.tab');
				foreach ($_filterArray as $_key => $_line)
				{
					if (strpos($_line, 'spam') !== false)
					{
						if ($_isBSet)
						{
							$_filterArray[$_key] = ltrim(trim($_line), '#');
						}
						else
						{
							if (strlen($_line) > 0 && $_line{0} != '#')
							{
								$_filterArray[$_key] = '#'.$_line;
							}
						}
					}
					else if (strpos($_line, 'virus') !== false)
					{
						if ($_isVSet)
						{
							$_filterArray[$_key] = ltrim(trim($_line), '#');
						}
						else
						{
							if (strlen($_line) > 0 && $_line{0} != '#')
							{
								$_filterArray[$_key] = '#'.$_line;
							}
						}
					}
				}
				
				return $this->_wmserver->SetTabFile('filters.in.tab', $_filterArray);
			}
			
			return false;
		}
		
		
		/**
		 * @return array
		 */
		function _isBayesianAndVirusFilterOn()
		{
			$_resp = array(false, false);
			if ($this->Connect())
			{
				$_filterArray = $this->_wmserver->GetTabFile('filters.in.tab');
				foreach ($_filterArray as $_line)
				{
					if (strlen($_line) > 0 && $_line{0} != '#')
					{
						$_line = strtolower($_line);
						if (strpos($_line, 'spam') !== false)
						{
							$_resp[0] = true;
						}
						else if (strpos($_line, 'virus') !== false)
						{
							$_resp[1] = true;
						}
					}
				}
			}
			
			return $_resp;
		}
		
		function InitScreen(&$screen, $action) 
		{
			switch ($action)
			{
				case 'initRootPath':
					$screen->_rootPath =& $this->_pluginInfo->Path;
					return true;
				case 'initMenu':
					$this->_initMenu($screen);
					return true;
				case 'initStandardData':
					$this->_initXmailData($screen);
					return true;
				case 'initFilter':
					$this->_initFilter($screen);
					return true;
				case 'initSearch':
					$this->_initSearch($screen);
					return true;
				case 'initTable':
					$this->_initTable($screen);
					return true;
				case 'initMain':
					$this->_initMain($screen);
					return true;

			}
			
			return false;
		}
		
		function IncludeCommon()
		{
			$_pp = $this->PluginPath();
			include $_pp.'/common/constans.php';
			include $_pp.'/common/settings.php';
			include $_pp.'/common/class_xmail.php';
			include $_pp.'/common/tabconfig.php';
			
			$this->_initSession();
		}
		
		/**
		 * @return bool
		 */
		function Connect()
		{
			if ($this->_isConnect)
			{
				CAdminPanel::Log('XM : Repeating a connection (return true)');
				return true;
			}

			if ($this->_settings)
			{
				$this->_wmserver = new CWmServerConsole($this->_settings->_login,
										$this->_settings->_password,
										$this->_settings->_host,
										$this->_settings->_port);
										
				if ($this->_wmserver->Connect())
				{
					$this->_isConnect = true;
				}
			}
			
			return $this->_isConnect;
		}
		
		function Disconnect()
		{
			if ($this->_isConnect && $this->_wmserver)
			{
				$this->_wmserver->Disconnect();
				$this->_isConnect = false;
			}
		}
		
		/**
		 * @return bool
		 */
		function IsWebMailExist()
		{
			return in_array(AP_TYPE_WEBMAIL, $this->_pluginIndexs);
		}
		
		/**
		 * @param string $action
		 * @param array $arg
		 * @return bool
		 */
		function GlobalFunction($action, $arg = array())
		{
			switch ($action)
			{
				case 'setAdminAuth':
					$result = true;
					if (isset($arg['password']) && isset($arg['login']) && $arg['password'] !== null)
					{
						if ($this->Connect())
						{
							$adminExist = false;
							$recordChange = false;
							$file = $this->_wmserver->GetTabFile('ctrlaccounts.tab');
							foreach ($file as $idx => $line)
							{
								$adminArray = explode(AP_TAB, $line);
								if (count($adminArray) == 2)
								{
									if ($arg['login'] == trim($adminArray[0], '"'))
									{
										$file[$idx] = $adminArray[0].AP_TAB.$this->EncryptPassword($arg['password']);
										$adminExist = $recordChange = true;
									}
								}
							}
							
							if (!$adminExist)
							{
								$file[] = '"'.$arg['login'].'"'.AP_TAB.$this->EncryptPassword($arg['password']);
								$recordChange = true;
							}
							
							if ($recordChange)
							{
								$result &= $this->_wmserver->SetTabFile('ctrlaccounts.tab', $file);
							}
							
							$this->Disconnect();
						}
						else
						{
							$this->_setError(ap_Utils::TakePhrase('XM_CANTCONNECT'));
						}
					}

					return $result;
					break;
			}

			return true;
		}
		
		function _initSearch(&$screen)
		{
			if (strlen($this->_searchDesc) > 0)
			{
				$screen->SetSearchDesc($this->_searchDesc);
			}
		}
		
		function _initFilter(&$screen)
		{
			if ($this->_ap->Tab() == 'users')
			{
				if ($this->Connect())
				{
					$screen->InitFilter();		
					
					$domains = $this->_wmserver->DomainList();
					foreach ($domains as $domain)
					{
						$filterItem = new ap_Screen_Filter_Item();
						$filterItem->href = AP_TYPE_XMAIL.AP_TYPE_DELIMITER.$domain;
						$filterItem->name = $domain;
						$filterItem->type = AP_TYPE_XMAIL;
						$filterItem->class = 'domXMail';
						
						$screen->_filter->AddItem($filterItem);
						unset($filterItem);
					}
				}
				else
				{
					$this->_setError(ap_Utils::TakePhrase('XM_CANTCONNECT'));
				}
			}
		}
		
		function _initMenu(&$screen)
		{
			switch ($this->_ap->Tab())
			{
				case 'xmail':
					$screen->AddMenuItem('mode_help', 'restart_help', 'restart-help.php', null, true);
					$screen->AddMenuItem(XM_MODE_SMTP, XM_TABNAME_SMTP, 'smtp.php');
					$screen->AddMenuItem(XM_MODE_POP3, XM_TABNAME_POP3, 'pop3.php');
					if ($this->_ap->Ptype())
					{
						$screen->AddMenuItem(XM_MODE_IMAP4, XM_TABNAME_IMAP4, 'imap4.php');
					}
					$screen->AddMenuItem(XM_MODE_ERRORS, XM_TABNAME_ERRORS, 'errors.php');
					$screen->AddMenuItem(XM_MODE_SPAM, XM_TABNAME_SPAM, 'spam.php');
					if ($this->_isDisplayAdvanced())
					{
						$screen->AddMenuItem(XM_MODE_MISC, XM_TABNAME_MISC, 'misc.php');	
					}
					$screen->AddMenuItem(XM_MODE_LOGGING, XM_TABNAME_LOGGING, 'logging.php');
					$screen->AddMenuItem(XM_MODE_ADMIN, XM_TABNAME_ADMIN, 'admin.php');
					$screen->SetDefaultMode(XM_MODE_SMTP);
					break;
					
				case 'users':
					$screen->AddTopMenuButton('New User', 'new_contact.gif', 'DoNew("new", "'.AP_INDEX_FILE.'");');
					$screen->AddTopMenuButton('Delete', 'delete.gif', 'DoDeleteUsers();', null,  true);
					break;
					
				case 'domains':
					$screen->AddTopMenuButton('New Domain', 'new-domain.png', 'DoNew("int", "'.AP_INDEX_FILE.'");');
					$screen->AddTopMenuButton('New Forwarded Domain', 'new-domain.png', 'DoNew("forw", "'.AP_INDEX_FILE.'");');
					$screen->AddTopMenuButton('Delete', 'delete.gif', 'DoDeleteDomains();', null, true);
					break;
			}
		}
		
		function _initSession()
		{
			$this->_settings = new Xmail_Settings($this->_ap);
			if (!$this->_settings->IsLoad)
			{
				$this->_settings = null;	
			}
		}
		
		function _initTable(&$screen)
		{
			if ($this->_ap->Tab() == 'domains')
			{
				$screen->SetNullPhrase(ap_Utils::TakePhrase('LANG_NODOMAINS'));
				$screen->InitTable();
				
				$screen->ClearHeaders();
				$screen->AddHeader('Type', 42);
				$screen->AddHeader('Name', 138, true);
				
				$this->_initDomainsData($screen);
			}
			else if ($this->_ap->Tab() == 'users')
			{
				$screen->SetNullPhrase(ap_Utils::TakePhrase('LANG_NOUSERSINDOMAIN'));
				$screen->InitTable();
				
				$screen->ClearHeaders();
				$screen->AddHeader('Type', 30);
				$screen->AddHeader('Email', 138, true);
					
				$this->_initUsersData($screen);
			}
		}
		
		function _initMain(&$screen)
		{
			if ($this->_ap->Tab() == 'domains')
			{
				switch ($this->_ap->Mode())
				{
					case 'new':
						$switcher = null;
						$type = null;
						if (isset($_GET['type']))
						{
							$type = $_GET['type'];
						}

						switch ($type)
						{
							case 'int':
								$screen->_main->AddSwitcher('int', 'This is internal domain', $this->PluginPath().'/templates/new-domain.php');
								$switcher =& $screen->_main->GetSwitcher('int');
								break;
							case 'forw':
								$screen->_main->AddSwitcher('forw', 'This is forwarded domain', $this->PluginPath().'/templates/new-virtdomain.php');
								$switcher =& $screen->_main->GetSwitcher('forw');
								break;
						}
						
						if ($switcher !== null)
						{
							include_once $this->PluginPath().'/common/class_domains.php';
							
							$domain = new CXMailDomain();
							$domain->UpdateFromSessionArray();

							$this->_updateScreenDataFromDomain($switcher->data, $domain);
							
							$switcher->data->SetValue('AdvancedOptionsSwitcherClass', ($this->_isDisplayAdvanced()) ? 'wm_settings_accounts_info' : 'wm_hide');
						}
						break;
						
					case 'edit':
						if (isset($_GET['uid']) && strlen($_GET['uid']) > 3 && strpos($_GET['uid'], AP_TYPE_XMAIL) !== false)
						{
							if ($this->Connect())
							{
								$ret = array();
								$domainName = '';
								$domainType = AP_TYPE_XMAIL;
								
								$uid = $this->_thisIsMyUid($_GET['uid']);
								if ($uid !== false)
								{
									$arr = ap_Utils::UidExplode($uid);
									if (strlen($arr[0]) > 0)
									{
										$domainType = $arr[0];
										$domainName = $arr[1];
									}
								}
								if (strlen($domainName) > 0)
								{
									include_once $this->PluginPath().'/common/class_domains.php';
								
									$domain = new CXMailDomain();
									$domain->_name = $domainName;
									
									if ($domainType == AP_TYPE_XMAIL_CUSTOM)
									{
										$ret = $this->_wmserver->GetMailProc($domainName, '');
										$domain->UpdateFromGetMailProc($ret);
										$screen->_main->AddSwitcher('edit', 'This is edit domain', $this->PluginPath().'/templates/edit-vdomain.php');
									}
									else
									{
										$screen->_main->AddSwitcher('edit', 'This is edit domain', $this->PluginPath().'/templates/edit-domain.php');
									}
									
									$switcher =& $screen->_main->GetSwitcher('edit');
									if ($switcher !== null)
									{
										$switcher->data->SetValue('uid', $_GET['uid']);
										
										$domain->UpdateFromSessionArray();
									
										$this->_updateScreenDataFromDomain($switcher->data, $domain);
										
										$switcher->data->SetValue('AdvancedOptionsSwitcherClass', ($this->_isDisplayAdvanced()) ? 'wm_settings_accounts_info' : 'wm_hide');
									}
								}
							}
							else
							{
								$this->_setError(ap_Utils::TakePhrase('XM_CANTCONNECT'));
							}
						}
						break;
				}
			}
			else if ($this->_ap->Tab() == 'users')
			{
				$xm_domain = '';
				$key = $screen->GetSelectedItemKey();
				$resp = $this->_thisIsMyUid($key);
				
				if ($resp !== false)
				{
					$arr = ap_Utils::UidExplode($resp);
					if (strlen($arr[0]) > 0)
					{
						$xm_domain = $arr[1];
					}
				}
				
				switch ($this->_ap->Mode())
				{
					case 'new':
	
						if ($this->_thisIsMyUid($key) !== false)
						{
							$switcher = null;
							$type = 'new';
							if (isset($_GET['type']))
							{
								$type = $_GET['type'];
							}
							
							if ($type == 'new')
							{
								$screen->_main->AddSwitcher('new', 'This is new xmail user', $this->PluginPath().'/templates/new-user.php');
								$switcher =& $screen->_main->GetSwitcher('new');
							}
							else if ($type == 'mlist')
							{
								$screen->_main->AddSwitcher('mlist', 'This is new mlist user', $this->PluginPath().'/templates/new-maillist.php');
								$switcher =& $screen->_main->GetSwitcher('mlist');
							}
							
							if ($switcher !== null)
							{
								include $this->PluginPath().'/common/class_user_mini.php';
								
								$UserMini = new CXMailUserMini();
								
								$UserMini->UpdateFromSessionArray();
								
								$switcher->data->SetValue('UserLogin', $UserMini->_login);
								$switcher->data->SetValue('DomainName', $xm_domain);
							}
						}
						break;
						
					case 'edit':
						
						if (strlen($xm_domain) > 0 && isset($_GET['uid']))
						{
							$userLogin = '';
							 
							$resp = $this->_thisIsMyUid($_GET['uid']);
							if ($resp !== false)
							{
								$arr = ap_Utils::UidExplode($resp);
								if (strlen($arr[0]) > 0)
								{
									$userLogin = $arr[1];
								}
							}
							
							if (strlen($userLogin) > 0)
							{
								include $this->PluginPath().'/common/class_user.php';
								$user = new CXMailUser();
								$user->_email = $userLogin.'@'.$xm_domain;
								
								if ($this->Connect())
								{
									$switcher = null;
									$isMLUser = $this->_wmserver->IsMultiListUser($xm_domain, $userLogin);
									$isXmUser = $this->_thisIsWmUid($_GET['uid']);
									
									if ($isMLUser)
									{
										$screen->_main->AddSwitcher('edit', 'This is new xmail user', $this->PluginPath().'/templates/edit-xm-maillist.php');	
									}
									else
									{
										if ($isXmUser !== false)
										{
											$screen->_main->AddSwitcher('edit', 'This is new xmail user', $this->PluginPath().'/templates/edit-xm-wm-user.php');
										}
										else
										{
											$screen->_main->AddSwitcher('edit', 'This is new xmail user', $this->PluginPath().'/templates/edit-xm-user.php');
										}
									}
									
									$switcher =& $screen->_main->GetSwitcher('edit');
									
									if ($switcher != null)
									{
										$switcher->data->SetValue('uid', $_GET['uid']);
										
										if($user->IsSessionData())
										{
											$user->UpdateFromSessionArray();
										}
										else
										{
											$user->UpdateFromUserVars($this->_wmserver->GetUserVars($xm_domain, $userLogin));
											$user->UpdateFromAliasList($this->_wmserver->AliasList($xm_domain, '*', $userLogin));
											$user->UpdateFromGetMailProc($this->_wmserver->GetMailProc($xm_domain, $userLogin));
											
											if ($isMLUser)
											{
												$user->UpdateFromMlUserList($this->_wmserver->MlUserList($xm_domain, $userLogin));
											}
										}
										
										
										$switcher->data->SetValue('UserPassword_PassMode', AP_DUMMYPASSWORD);
										$switcher->data->SetValue('DomainNameAlias', $xm_domain);
										
										$this->_updateScreenDataFromUser($switcher->data, $user);
										
										$start = 1;
										if (isset($_GET['start']))
										{
											$start = (int) $_GET['start'];
										}
										
										$focusString = ($start > 1) ?  '$("AccountAliasID").focus();' : '';
										$switcher->data->SetValue('StartJs', '
SwitchItem(virtdomaintabs, "content_custom_tab_'.$start.'"); SetAllOf();
var startTab = document.getElementById("custom_tab_'.$start.'"); 
if (startTab) { startTab.className = "wm_settings_switcher_select_item"; };
'.$focusString);
										
									}
								}
							}
						}
						break;
				}
			}
		}
		
		function _initDomainsData(&$screen)
		{
			if ($this->Connect())
			{
				$domains = $this->_wmserver->DomainList();
				$cdomains = $this->_wmserver->CustomDomainList();
				
				foreach ($domains as $domain)
				{
					if (strlen($this->_searchDesc) > 0 && strpos($domain, $this->_searchDesc) === false)
					{
						continue;
					}
					
					$tableItem = new ap_Screen_Table_Item();
					$tableItem->href = AP_TYPE_XMAIL.AP_TYPE_DELIMITER.$domain;
					$tableItem->name = $domain;
					$tableItem->type = AP_TYPE_XMAIL;
					$tableItem->values = array(
						'Type' => '<img src="'.$this->_ap->AdminFolder().'/images/xmail-domain-icon-big.png">',
						'Name' => $domain
					);
					
					$screen->_table->AddItem($tableItem);
					unset($tableItem);
				}

				foreach ($cdomains as $domain)
				{
					if (strlen($this->_searchDesc) > 0 && strpos($domain, $this->_searchDesc) === false)
					{
						continue;
					}
					
					$tableItem = new ap_Screen_Table_Item();
					$tableItem->href = AP_TYPE_XMAIL_CUSTOM.AP_TYPE_DELIMITER.$domain;
					$tableItem->name = $domain;
					$tableItem->type = AP_TYPE_XMAIL_CUSTOM;
					$tableItem->values = array(
						'Type' => '<img src="'.$this->_ap->AdminFolder().'/images/xmail-domain-icon-big.png">',
						'Name' => $domain
					);

					$screen->_table->AddItem($tableItem);
					unset($tableItem);
				}
			}
			else
			{
				$this->_setError(ap_Utils::TakePhrase('XM_CANTCONNECT'));
			}
		}
		
		function _initUsersData(&$screen)
		{
			if ($this->Connect())
			{
				$AllUsersCount = (int) $this->_wmserver->GetUsersCount('*');
				$screen->SetLowToolBarText(ap_Utils::TakePhrase('LANG_TOTAL_USERS').': '.$AllUsersCount);
			}
			else
			{
				$this->_setError(ap_Utils::TakePhrase('XM_CANTCONNECT'));
				return true;
			}
			
			$domainKey = $screen->GetSelectedItemKey();
			if ($this->_thisIsWmUid($domainKey))
			{
				return true;
			}
			
			include_once $this->PluginPath().'/common/class_domains.php';
							
			$domainType = AP_TYPE_XMAIL;
			$domainName = '';
			
			$uids = explode(AP_UIDS_DELIMITER, $domainKey);
			foreach ($uids as $value)
			{
				if (substr($value, 0, 2) == AP_TYPE_XMAIL)
				{
					$arr = ap_Utils::UidExplode($value);
					if (strlen($arr[0]) > 0)
					{
						$domainType = $arr[0];
						$domainName = $arr[1];
						break;
					}
				}
			}
			
			$users = null;
			if (strlen($domainName) > 0 && $domainType == AP_TYPE_XMAIL)
			{
				$screen->AddTopMenuButton('New Mailing List', 'new_contact.gif', 'DoNew("mlist", "'.AP_INDEX_FILE.'");');
				
				$screen->ClearHeaders();
				$screen->AddHeader('Type', 30);
				$screen->AddHeader('Email', 138, true);
				$screen->UseSort(false);
				
				if (strlen($this->_searchDesc) > 0)
				{
					$UsersCount = $this->_wmserver->GetUsersCount($domainName, '*'.$this->_searchDesc.'*');
				}
				else
				{
					$UsersCount = $this->_wmserver->GetUsersCount($domainName);
				}
				
				if ($UsersCount > 0)
				{
					$screen->_table->UseCurrentList();
					$screen->_table->SetListCount($UsersCount);
					$page = $screen->_table->GetPage($UsersCount);
					
					$username = strlen($this->_searchDesc) > 0 ? '*'.$this->_searchDesc.'*' : '';
					$users = $this->_wmserver->UserList($domainName, $username, ($page - 1) * $screen->_table->GetLinePerPage(), $screen->_table->GetLinePerPage());
					
					if ($users && is_array($users))
					{
						foreach ($users as $user)
						{
							if (is_array($user) && count($user) == 4)
							{
								$tableItem = new ap_Screen_Table_Item();
								$tableItem->href = AP_TYPE_XMAIL.AP_TYPE_DELIMITER.$user[1];
								$tableItem->name = $user[1];
								$tableItem->type = AP_TYPE_XMAIL;
								
								$img = ($user[3] == 'M') ? 'M.gif': 'U.gif';
								$tableItem->values = array(
									'Type' => '<img src="'.$this->_ap->AdminFolder().'/images/icons/'.$img.'">',
									'Email' => $user[1].'@'.$domainName
								);
								
								$screen->_table->AddItem($tableItem);
								unset($tableItem);
							}
						}
					}
				}
			}
			
			return true;
		}
		
		function _initXmailData(&$screen)
		{
			$screen->AddGlobalJs('xmail.js');

			$tc = new Xmail_TabConfig();

			if ($this->Connect())
			{
				if (ap_Utils::IsWin())
				{
					$screen->data->SetValue('class_LinuxDiv', 'wm_hide');
				}
				else
				{
					$screen->data->SetValue('class_WinDiv', 'wm_hide');
				}
				
				$screen->data->SetValue('class_Advanced', ($this->_isDisplayAdvanced()) ? '': 'class="wm_hide"');
				
				$tab = $this->_wmserver->GetTabFile('server.tab');
				foreach ($tab as $line)
				{
					$tc->AddLine(new Xmail_TabConfigLine($line));
				}
				
				if (!$tc->GetBoolValueByKey('Imap4_DLL'))
				{
					$screen->DeleteMenuItem(XM_MODE_IMAP4);
				}
				
				/* smtp */
				$screen->data->SetValue('box_SmtpProto', $tc->GetBoolValueByKey('SmtpProto'));
				$screen->data->SetValue('var_SmtpPort', $tc->GetValueByKey('SmtpPort'));
				$screen->data->SetValue('var_SmtpPortSSL', $tc->GetValueByKey('SmtpPortSSL'));
				$screen->data->SetValue('box_EnableSMTP_TLS', $tc->GetBoolValueByKey('EnableSMTP-TLS'));
				$screen->data->SetValue('box_EnableAuthSMTP_POP3', $tc->GetBoolValueByKey('EnableAuthSMTP-POP3'));

				if (!$tc->IsCommentValue('SmtpGwConfig'))
				{
					$screen->data->SetValue('check_SmtpGwConfig', true);
				}
				$value = $tc->GetValueByKey('SmtpGwConfig');
				$screen->data->SetValue('var_SmtpGwConfig', $value);
				if ($value == 'NeedTLS=1,OutBind=192.168.1.1')
				{
					$screen->data->SetValue('SmtpGlobalGatewayOptionsDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('SmtpGlobalGatewayOptionsCustomRadioID', true);
				}

				if (!$tc->IsCommentValue('DefaultSMTPGateways'))
				{
					$screen->data->SetValue('check_DefaultSMTPGateways', true);
				}
				$value = $tc->GetValueByKey('DefaultSMTPGateways');
				$screen->data->SetValue('var_DefaultSMTPGateways', $value);
				if ($value == '192.168.1.2,192.168.1.15')
				{
					$screen->data->SetValue('DefaultSmtpGatewayListDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('DefaultSmtpGatewayListCustomRadioID', true);
				}
				
				if (!$tc->IsCommentValue('SmtpConfig'))
				{
					$screen->data->SetValue('check_SmtpConfig', true);
				}
				$value = $tc->GetValueByKey('SmtpConfig');
				$screen->data->SetValue('var_SmtpConfig', $value);
				if ($value == 'mail-auth')
				{
					$screen->data->SetValue('SmtpAuthDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('SmtpAuthCustomRadioID', true);
				}

				if (!$tc->IsCommentValue('DefaultSmtpPerms'))
				{
					$screen->data->SetValue('check_DefaultSmtpPerms', true);
				}
				$value = $tc->GetValueByKey('DefaultSmtpPerms');
				$screen->data->SetValue('var_DefaultSmtpPerms', $value);
				if ($value == 'MRVZ')
				{
					$screen->data->SetValue('SmtpPermissionsDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('SmtpPermissionsCustomRadioID', true);
				}				
				
				$screen->data->SetValue('box_AllowSmtpVRFY', $tc->GetBoolValueByKey('AllowSmtpVRFY'));
				
				if (!$tc->IsCommentValue('MaxMessageSize'))
				{
					$screen->data->SetValue('check_MaxMessageSize', true);
				}
				$screen->data->SetValue('var_MaxMessageSize', $tc->GetValueByKey('MaxMessageSize'));
				
				/* pop3 */
				$screen->data->SetValue('box_Pop3Proto', $tc->GetBoolValueByKey('Pop3Proto'));
				$screen->data->SetValue('var_Pop3Port', $tc->GetValueByKey('Pop3Port'));
				$screen->data->SetValue('var_Pop3PortSSL', $tc->GetValueByKey('Pop3PortSSL'));
				$screen->data->SetValue('box_EnablePOP3_TLS', $tc->GetBoolValueByKey('EnablePOP3-TLS'));
				
				/* imap4 */
				$screen->data->SetValue('box_Imap4Proto', $tc->GetBoolValueByKey('Imap4Proto'));
				$screen->data->SetValue('var_Imap4Port', $tc->GetValueByKey('Imap4Port'));
				$screen->data->SetValue('var_Imap4PortSSL', $tc->GetValueByKey('Imap4PortSSL'));
				
				/* domains */
				$screen->data->SetValue('var_RootDomain', $tc->GetValueByKey('RootDomain'));
				
				if (!$tc->IsCommentValue('HeloDomain'))
				{
					$screen->data->SetValue('check_HeloDomain', true);	
				}
				$screen->data->SetValue('var_HeloDomain', $tc->GetValueByKey('HeloDomain'));
				
				if (!$tc->IsCommentValue('SmtpServerDomain'))
				{
					$screen->data->SetValue('check_SmtpServerDomain', true);	
				}
				$screen->data->SetValue('var_SmtpServerDomain', $tc->GetValueByKey('SmtpServerDomain'));
				
				if (!$tc->IsCommentValue('POP3Domain'))
				{
					$screen->data->SetValue('check_POP3Domain', true);	
				}
				$screen->data->SetValue('var_POP3Domain', $tc->GetValueByKey('POP3Domain'));
				
				/* errors */
				$screen->data->SetValue('var_ErrorsAdmin', $tc->GetValueByKey('ErrorsAdmin'));
				$screen->data->SetValue('var_TempErrorsAdmin', $tc->GetValueByKey('TempErrorsAdmin'));
				$screen->data->SetValue('var_NotifyMsgLinesExtra', $tc->GetValueByKey('NotifyMsgLinesExtra'));
				$screen->data->SetValue('box_NotifySendLogToSender', $tc->GetBoolValueByKey('NotifySendLogToSender'));
				$screen->data->SetValue('var_SMTP_MaxErrors', $tc->GetValueByKey('SMTP-MaxErrors'));

				if (!$tc->IsCommentValue('CustomSMTPMessage'))
				{
					$screen->data->SetValue('check_CustomSMTPMessage', true);	
				}
				$screen->data->SetValue('var_CustomSMTPMessage', $tc->GetValueByKey('CustomSMTPMessage'));
				
				if (!$tc->IsCommentValue('CustMapsList'))
				{
					$screen->data->SetValue('check_CustMapsList', true);
				}
				$value = $tc->GetValueByKey('CustMapsList');
				$screen->data->SetValue('var_CustMapsList', $value);
				if ($value == 'list.dsbl.org.:1,blackholes.mail-abuse.org.:1,dialups.mail-abuse.org.:0')
				{
					$screen->data->SetValue('CustMapsListDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('CustMapsListCustomRadioID', true);
				}				
				
				if (!$tc->IsCommentValue('NotifyTryPattern'))
				{
					$screen->data->SetValue('check_NotifyTryPattern', true);	
				}
				$screen->data->SetValue('var_NotifyTryPattern', $tc->GetValueByKey('NotifyTryPattern'));
				
				if (!$tc->IsCommentValue('Pop3SyncErrorAccount'))
				{
					$screen->data->SetValue('check_Pop3SyncErrorAccount', true);	
				}
				$screen->data->SetValue('var_Pop3SyncErrorAccount', $tc->GetValueByKey('Pop3SyncErrorAccount'));

				if (!$tc->IsCommentValue('RemoveSpoolErrors'))
				{
					$screen->data->SetValue('box_RemoveSpoolErrors', $tc->GetBoolValueByKey('RemoveSpoolErrors'));	
				}
				
				/* spam and virus*/
				$_resp = $this->_isBayesianAndVirusFilterOn();
				$screen->data->SetValue('box_AllowNullSender', $tc->GetBoolValueByKey('AllowNullSender'));
				$screen->data->SetValue('box_CheckMailerDomain', $tc->GetBoolValueByKey('CheckMailerDomain'));
				$screen->data->SetValue('box_SMTP_RDNSCheck', $tc->GetBoolValueByKey('SMTP-RDNSCheck'));
				$screen->data->SetValue('box_BayesianCheck', $_resp[0]);
				$screen->data->SetValue('box_AntivirusCheck', $_resp[1]);
				$screen->data->SetValue('var_SmtpMsgIPBanSpammers', $tc->GetValueByKey('SmtpMsgIPBanSpammers'));
				
				/* misc */
				$screen->data->SetValue('box_FingerProto', $tc->GetBoolValueByKey('FingerProto'));
				$screen->data->SetValue('var_FingerPort', $tc->GetValueByKey('FingerPort'));
				$screen->data->SetValue('var_MaxMTAOps', $tc->GetValueByKey('MaxMTAOps'));
				
				$value = $tc->GetValueByKey('SmartDNSHost');
				if ($value == 'dns.home.bogus.net:tcp,192.168.1.1:udp')
				{
					$screen->data->SetValue('SmartDnsHostDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('SmartDnsHostCustomRadioID', true);
				}
				$screen->data->SetValue('var_SmartDNSHost', $value);
				
				if (!$tc->IsCommentValue('SmtpMinDiskSpace'))
				{
					$screen->data->SetValue('check_SmtpMinDiskSpace', true);
				}
				$screen->data->SetValue('var_SmtpMinDiskSpace', $tc->GetValueByKey('SmtpMinDiskSpace'));

				if (!$tc->IsCommentValue('SmtpMinVirtMemSpace'))
				{
					$screen->data->SetValue('check_SmtpMinVirtMemSpace', true);
				}
				$screen->data->SetValue('var_SmtpMinVirtMemSpace', $tc->GetValueByKey('SmtpMinVirtMemSpace'));

				if (!$tc->IsCommentValue('Pop3MinVirtMemSpace'))
				{
					$screen->data->SetValue('check_Pop3MinVirtMemSpace', true);
				}
				$screen->data->SetValue('var_Pop3MinVirtMemSpace', $tc->GetValueByKey('Pop3MinVirtMemSpace'));
				
				if (!$tc->IsCommentValue('FetchHdrTags'))
				{
					$screen->data->SetValue('check_FetchHdrTags', true);
				}
				$value = $tc->GetValueByKey('FetchHdrTags');
				if ($value == '+X-Deliver-To,+Received,To,Cc')
				{
					$screen->data->SetValue('FetchHeaderTagsDefaultRadioID', true);
				}
				else
				{
					$screen->data->SetValue('FetchHeaderTagsCustomRadioID', true);
				}
				$screen->data->SetValue('var_FetchHdrTags', $value);
				
				$screen->data->SetValue('box_DisableEmitAuthUser', $tc->GetBoolValueByKey('DisableEmitAuthUser'));
				
				if (!$tc->IsCommentValue('ReceivedHdrType'))
				{
					$screen->data->SetValue('check_ReceivedHdrType', true);
				}
				$value = (int) $tc->GetValueByKey('ReceivedHdrType');
				$screen->data->SetValue('sel_ReceivedHdrType'.$value, true);
				
				/* logging */
				$screen->data->SetValue('box_LogSystem', $tc->GetBoolValueByKey('LogGLOBAL'));
				$screen->data->SetValue('box_LogSMTP', $tc->GetBoolValueByKey('LogSMTP'));
				$screen->data->SetValue('box_LogPOP3', $tc->GetBoolValueByKey('LogPOP3'));
				$screen->data->SetValue('box_Pop3LogPasswd', $tc->GetBoolValueByKey('Pop3LogPasswd'));
				$screen->data->SetValue('box_LogIMAP4', $tc->GetBoolValueByKey('LogIMAP4'));
				$screen->data->SetValue('box_LogCTRL', $tc->GetBoolValueByKey('LogCTRL'));
				$screen->data->SetValue('box_LogLMAIL', $tc->GetBoolValueByKey('LogLMAIL'));
				$screen->data->SetValue('box_LogSMAIL', $tc->GetBoolValueByKey('LogSMAIL'));
				
				/* admin */
				if (ap_Utils::IsWin())
				{
					$screen->data->SetValue('hideWinClass', 'class="wm_hide"');	
				}
				$screen->data->SetValue('var_User', $tc->GetValueByKey('User'));
				$screen->data->SetValue('var_Group', $tc->GetValueByKey('Group'));
				$screen->data->SetValue('var_PostMaster', $tc->GetValueByKey('PostMaster'));
				$screen->data->SetValue('ch_DisplayAdvanced', $this->_isDisplayAdvanced());
				$screen->data->SetValue('box_ControlProto', $tc->GetBoolValueByKey('ControlProto'));
				$screen->data->SetValue('var_ControlPort', $tc->GetValueByKey('ControlPort'));
				$screen->data->SetValue('var_ControlPortSSL', $tc->GetValueByKey('ControlPortSSL'));
				$screen->data->SetValue('box_EnableCTRL_TLS', $tc->GetBoolValueByKey('EnableCTRL-TLS'));
				if ($this->_isDisplayAdvanced())
				{
					$screen->data->SetValue('changingSettingsClass', 'wm_secondary_info');	
				}
				else 
				{
					$screen->data->SetValue('changingSettingsClass', 'wm_hide');
				}
				
				/* end */ 
				$this->_wmserver->Disconnect();
			}
			else
			{
				$this->_setError(ap_Utils::TakePhrase('XM_CANTCONNECT'));
			}
		}
		
		/**
		 * @return	bool
		 */
		function _isDisplayAdvanced()
		{
			$_cfg =& $this->_ap->Config();
			return isset($_cfg['advancedoptions']) && $_cfg['advancedoptions'];
		}
		
		/**
		 * @param ap_Screen_Data $data
		 * @param CXMailDomain $domain
		 */		
		function _updateScreenDataFromDomain(&$data, &$domain)
		{
			$data->SetValue('DomainName', $domain->_name);
			$text = '';
			foreach ($domain->_act_forwards as $value)
			{
				$text .= '<option value="'.ap_Utils::AttributeQuote($value).'">'.ap_Utils::EncodeSpecialXmlChars($value).'</option>';	
			}
			if (strlen($text) > 0)
			{
				$data->SetValue('LRedirectionsListDDL', $text);
				$text = '';
			}
			
			$data->SetValue('AdvancedID', $domain->_customDomainProcessing);
		}

		/**
		 * @param	ap_Screen_Data	$data
		 * @param	CXMailUser	$user
		 */
		function _updateScreenDataFromUser(&$data, &$user)
		{
			$data->SetValue('UserEmail', $user->_email);
			$data->SetValue('MaxMailboxSize', (int) round($user->_mailBoxSize / 1024));
			$data->SetValue('StoreMailLocalyID', (bool) $user->_storeMailInMailbox);
			
			$text = '';
			foreach ($user->_mlusers as $item)
			{
				if (is_array($item) && count($item) == 2)
				{
					$type = $item[1];
					$mtype = ($type == 'R') ? 'RS' : @substr($type, 0, 2);
					$type = ($type == 'RA' || $type == 'RW') ? 'Read/Post' : 'Read';
					
					$value = ap_Utils::AttributeQuote($mtype.'|'.$item[0]);
					$name = ap_Utils::EncodeSpecialXmlChars($item[0].' ('.$type.')');
					$mtype = ap_Utils::AttributeQuote($mtype);
					$text .= '<option mtype="'.$mtype.'" muser="'.$item[0].'" value="'.$value.'">'.$name.'</option>';
				}	
			}
			if (strlen($text) > 0)
			{
				$data->SetValue('ListMembersDDL', $text);
				$text = '';
			}			
			
			$text = '';
			foreach ($user->_alias as $value)
			{
				$text .= '<option value="'.ap_Utils::AttributeQuote($value).'">'.ap_Utils::EncodeSpecialXmlChars($value).'</option>';	
			}
			if (strlen($text) > 0)
			{
				$data->SetValue('AliasesListDDL', $text);
				$text = '';
			}
			
			foreach ($user->_act_forwards as $value)
			{
				$text .= '<option value="'.ap_Utils::AttributeQuote($value).'">'.ap_Utils::EncodeSpecialXmlChars($value).'</option>';	
			}
			if (strlen($text) > 0)
			{
				$data->SetValue('LRedirectionsListDDL', $text);
				$text = '';
			}
		}
		
		/**
		 * @param	CXMailUser	$user
		 */
		function _updateUserFromPost(&$user)
		{
			if (isset($_POST['uid']))
			{
				$resp = $this->_thisIsMyUid($_POST['uid']);
				if ($resp !== false)
				{
					$arr = ap_Utils::UidExplode($resp);
					if (strlen($arr[0]) > 0)
					{
						$user->_login = $arr[1];
					}
				}
			}
			
			$user->_mailBoxSize = isset($_POST['MaxMailboxSize']) ?  (int) $_POST['MaxMailboxSize'] : $user->_mailBoxSize;
			
			if (isset($_POST['UserPassword_PassMode']) && $_POST['UserPassword_PassMode'] != AP_DUMMYPASSWORD)
			{
				$user->_password = $_POST['UserPassword_PassMode'];
			}

			if (isset($_POST['ListMembersDDL']) && is_array($_POST['ListMembersDDL']) && count($_POST['ListMembersDDL']) > 0)
			{
				foreach ($_POST['ListMembersDDL'] as $memb)
				{
					$user->_mlusers[] = $memb;
				}
			}
			
			if (isset($_POST['AliasesListDDL']) && is_array($_POST['AliasesListDDL']) && count($_POST['AliasesListDDL']) > 0)
			{
				foreach ($_POST['AliasesListDDL'] as $alias)
				{
					$user->_alias[] = $alias;
				}
			}
			
			if (isset($_POST['LRedirectionsListDDL']) && is_array($_POST['LRedirectionsListDDL']) && count($_POST['LRedirectionsListDDL']) > 0)
			{
				foreach ($_POST['LRedirectionsListDDL'] as $lredirect)
				{
					$user->_act_forwards[] = $lredirect;
				}
			}
			
			$user->_storeMailInMailbox = isset($_POST['StoreMailLocalyID']);
		}
		
		/**
		 * @param string $uid
		 * @return false|string
		 */
		function _thisIsMyUid($uid)
		{
			$uids = explode(AP_UIDS_DELIMITER, $uid);
			foreach ($uids as $item)
			{
				if (AP_TYPE_XMAIL === substr($item, 0, 2))
				{
					return $item;
				}
			}
			
			return false;
		}
		
		/**
		 * @param string $uid
		 * @return bool
		 */
		function _thisIsWmUid($uid)
		{
			$uids = explode(AP_UIDS_DELIMITER, $uid);
			foreach ($uids as $item)
			{
				if (AP_TYPE_WEBMAIL === substr($item, 0, 2))
				{
					return true;
				}
			}
			
			return false;
		}
		
		/**
		 * @param	bool	$_displayAdvanced
		 * @return	bool
		 */
		function _saveDisplayAdvancedData($_displayAdvanced)
		{
			$_path = $this->_ap->GetCfg('adminpanel_data_path');
			$_xml = new XmlDocument();
			if($_path !== false && $_xml->LoadFromFile($_path.'/settings/'.AP_XML_CFG_FILE))
			{
				$_display_advanced =& $_xml->XmlRoot->GetChildNodeByTagName('advancedoptions');
				if ($_display_advanced)
				{
					$_display_advanced->Value = (int) $_displayAdvanced;
				}
				else
				{
					$_plugins = new XmlDomNode('advancedoptions', (int) $_displayAdvanced);
					$_xml->XmlRoot->AppendChild($_plugins);
				}
				
				if ($_xml->SaveToFile($_path.'/settings/'.AP_XML_CFG_FILE))
				{
					return true;
				}
			}
			return false;
		}
		
		/**
		 * @param	string	$string
		 * @return	string
		 */
		function DecryptPassword($string) 
		{
			$result = '';
			if (strlen($string) % 2 == 0) 
			{
				for ($i = 0; $i < strlen($string); $i+=2) 
				{
					$result .= chr((hexdec(substr($string, $i, 2)) ^ 101) & 0xFF);
				}
				return $result;
			} 

			return $result;
		}
		
		/**
		 * @param	string	$string
		 * @return	string
		 */		
		function EncryptPassword($string) 
		{
			$result = '';
			for ($i = 0; $i < strlen($string); $i++) 
			{
				$word = (ord($string{$i}) ^ 101) & 0xFF;
				$result .= ($word < 16) ? '0' . dechex($word) : dechex($word);
			}
			
			return strtoupper($result);
		}
	}