/*
 * Classes:
 *  CNewMessageScreen
 */

var PRIORITY_LOW = 5;
var PRIORITY_NORMAL = 3;
var PRIORITY_HIGH = 1;

function CNewMessageScreen(skinName)
{
	this.Id = SCREEN_NEW_MESSAGE;
	this.isBuilded = false;
	this.hasCopyright = false;
	this.BodyAutoOverflow = true;
	this._skinName = skinName;
	
	this.shown = false;
	this._idAcct = -1;
	
	this._msgObj = new CMessage();
	this._newMessage = true;
	this._fromField = '';
	this._sendersGroups = Array();

	this._showTextLabels = true;
	this._allowDhtmlEditor = true;

	this._mainContainer = null;
	this._toolBar = null;
	this._logo = null;
	this._accountsBar = null;
	this._headersTbl = null;
	this._uploadTbl = null;
	//logo + accountslist + toolbar
	this.ExternalHeight = 56 + 32 + 26 + 24;

	this._bccSwitcher = null;
	this._hasBcc = false;
	this._bccCont = null;

	this._fromObj = null;
	this._toObj = null;
	this._ccObj = null;
	this._bccObj = null;
	this._subjectObj = null;
	this._priorityLowButton = null;
	this._priorityNormalButton = null;
	this._priorityHighButton = null;
	this._priority = 3;

	this.AutoFilling = null;
	this.PopupContacts = null;
	
	this._modeSwitcher = null;
	this._modeSwitcherCont = null;
	this._mode = true;
	this._plainEditorObj = null;
	this._plainEditorDiv = null;
	this._plainEditorCont = null;
	
	this._uploadForm = null;
	this._attachments = Array();
	this._rowIndex = 0;
	this._attachmentsDiv = null;
	this._attachmentsTbl = null;
	
	this._signature = null;

	this._picturesControl = new CMessagePicturesController(this.ShowPictures, this);
	this._showPicturesTbl = null;
	
	this._saving = false;
	this._sending = false;
	this._messageLoaded = false;
	this._signatureLoaded = false;
	
}

CNewMessageScreen.prototype = {
	PlaceData: function (Data)
	{
		if (Data != null) {
			var Type = Data.Type;
			switch (Type){
				case TYPE_SIGNATURE:
					this._signature = Data;
					if (this._newMessage) {
						this.ChangeSignature();
						this._signatureLoaded = true;
						this.Fill();
					}
				break;
				case TYPE_CONTACTS:
					var iCount = Data.List.length;
					for (var i=0; i<iCount; i++) {
						if (Data.List[i].IsGroup) {
							Data.List[i].ImgSrc = 'skins/' + this._skinName + '/contacts/group.gif';
						}
						else {
							Data.List[i].ImgSrc = '';
						}
					};
					if (Data.LookFor == '') {
					    if (iCount == 0) {
					        this.PopupContacts.Hide();
						    WebMail.ShowReport(Lang.InfoNoContactsGroups);
					    }
					    else {
						    this.PopupContacts.Fill(Data.List, 'skins/' + this._skinName + '/contacts/close.gif');
					    }
					}
					else {
					    if (iCount == 0) {
					        this.AutoFilling.Hide();
					    }
					    else if (Data.Count > iCount) {
						    this.AutoFilling.Fill(Data.List, Data.LookFor, Lang.InfoListNotContainAddress);
					    }
					    else {
						    this.AutoFilling.Fill(Data.List, Data.LookFor, '');
					    }
					}
				break;
			}
		}
	},//PlaceData
	
	AddSenderGroup: function (id)
	{
		var hasValue = false;
		var iCount = this._sendersGroups.length;
		for (var i=0; i<iCount; i++) {
			if (this._sendersGroups[i] == id) {
				hasValue = true;
			}
		};
		if (!hasValue) {
			this._sendersGroups[iCount] = id;
		}
	},
	
	SetErrorHappen: function ()
	{
		this._saving = false;
		this._sending = false;
	},
	
	SetMessageId: function (id, uid)
	{
		this._saving = false;
		this._msgObj.Id = id;
		this._msgObj.Uid = uid;
	},
	
	Show: function (settings)
	{
		this._saving = false;
		this._sending = false;
		this._sendersGroups = Array();
		this.ParseSettings(settings);
		this._mainContainer.className = '';
		this._toolBar.Show();
		if (this._showTextLabels) {
			this._toolBar.ShowTextLabels();
		}
		else {
			this._toolBar.HideTextLabels();
		}
		if (this._allowDhtmlEditor) {
			HtmlEditorField.Show(7);
			HtmlEditorField.SetPlainEditor(this._plainEditorObj, this._modeSwitcher);
			HtmlEditorField.Replace();
		}
		this.shown = true;
		this.Fill();
		if (this._allowDhtmlEditor) {
			this._modeSwitcherCont.className = '';
		}
		else {
			this._modeSwitcherCont.className = 'wm_hide';
		}
		
	},
	
	ParseSettings: function (settings)
	{
		if (this._allowDhtmlEditor != settings.AllowDhtmlEditor) {
			this._allowDhtmlEditor = settings.AllowDhtmlEditor;
		}
		this._showTextLabels = settings.ShowTextLabels;
		this.ChangeSkin(settings.DefSkin);
	},
	
	ChangeSkin: function (newSkin)
	{
		if (this._skinName != newSkin) {
			this._skinName = newSkin;
		}
	},

	RestoreFromHistory: function (historyArgs)
	{
	},

	Hide: function ()
	{
		this.shown = false;
		this.SetNewMessage();
		if (this._allowDhtmlEditor) {
			HtmlEditorField.Hide();
		}
		this.PopupContacts.Hide();
		this.AutoFilling.Hide();
		this._mainContainer.className = 'wm_hide';
		this._toolBar.Hide();
		this._messageLoaded = false;
		this._signatureLoaded = false;
	},
	
	ClearForm: function ()
	{
		this._fromObj.value = '';
		this._toObj.value = '';
		this._ccObj.value = '';
		this._bccObj.value = '';
		this._subjectObj.value = '';
		if (this._allowDhtmlEditor) {
			HtmlEditorField.SetHtml('');
		}
		this._plainEditorObj.value = '';
	},
	
	EnableForm: function ()
	{
		this._fromObj.disabled = false;
		this._toObj.disabled = false;
		this._ccObj.disabled = false;
		this._bccObj.disabled = false;
		this._subjectObj.disabled = false;
		if (this._allowDhtmlEditor) {
			HtmlEditorField.Enable();
		}
		this._plainEditorObj.disabled = false;
		this._uploadFile.disabled = false;
	},
	
	DisableForm: function ()
	{
		// condition for ie6 on slow connections
		if (this.shown && !this._fromObj.disabled) {
			this._fromObj.focus();
		}
		this._fromObj.disabled = true;
		this._toObj.disabled = true;
		this._ccObj.disabled = true;
		this._bccObj.disabled = true;
		this._subjectObj.disabled = true;
		if (this._allowDhtmlEditor) {
			HtmlEditorField.Disable();
		}
		this._plainEditorObj.disabled = true;
		this._uploadFile.disabled = true;
	},
	
	ClickBody: function (ev)
	{
		if (this._allowDhtmlEditor && this._mode) {
			HtmlEditorField.ClickBody();
		}
		this.PopupContacts.ClickBody(ev);
		this.AutoFilling.ClickBody(ev);
	},

	GetExternalHeight: function()
	{
		var res = 0;
		var x;
		if (x = this._logo.offsetHeight) { res += x; }
		if (x = this._accountsBar.offsetHeight) { res += x; }
		if (x = this._toolBar.table.offsetHeight) { res += x; }
		if (x = this._headersTbl.offsetHeight) { res += x; }
		if (x = this._plainEditorCont.offsetHeight) { res -= x; }
		if (x = this._attachmentsDiv.offsetHeight) { res += x; }
		if (x = this._uploadTbl.offsetHeight) { res += x; }
		if (res != 0)
			this.ExternalHeight = res;
		return this.ExternalHeight;
	},
	
	ResizeBody: function (mode)
	{
		if (this.isBuilded) {
			var width = GetWidth();
			if (width < 684)
				width = 684;
			width = width - 40;
			var padding = 6;
			if (Browser.IE && Browser.Version < 7) {
				padding = 7;
			}
			var height = GetHeight() - this.GetExternalHeight() - padding;
			if (height < 300) height = 300;

			this._plainEditorDiv.style.height = height + 'px';
			this._plainEditorDiv.style.width = width + 'px';

			if (this._allowDhtmlEditor) {
				HtmlEditorField.Resize(width, height);
			}
			else {
				this._plainEditorObj.style.height = (height - 1) + 'px';
				this._plainEditorObj.style.width = (width - 2) + 'px';
			}
			this.PopupContacts.Replace();
			this.AutoFilling.Replace();
		}
	},
	
	SetNewMessage: function ()
	{
		this._newMessage = true;
		this._msgObj = new CMessage();
		this.ChangeFromAddr();
		this.ChangeSignature();
	},
	
	ChangeFromAddr: function ()
	{
		this._msgObj.FromAddr = this._fromField;
	},
	
	ChangeSignature: function ()
	{
		var value = '';
		if (null != this._signature && this._signature.Opt != 0) {
			value = this._signature.Value;
		}
		var prefix = '';
		if (value.length > 0) {
			if (this._allowDhtmlEditor && this._msgObj.HasHtml) {
				prefix = '<br/><br/>';
			}
			else {
				prefix = '\n\n';
			}
		}
		else if (Browser.Mozilla && this._allowDhtmlEditor && this._msgObj.HasHtml) {
			prefix = '<br/>';
		}
		if (this._allowDhtmlEditor && this._msgObj.HasHtml) {
			this._msgObj.HtmlBody = prefix + value;
		}
		else {
			if (null != this._signature && this._signature.isHtml) {
				this._msgObj.PlainBody = prefix + value.replace(/<br *\/{0,1}>/gi, '\n').replace(/<[^>]*>/g, '');
			}
			else {
				this._msgObj.PlainBody = prefix + value;
			}
			this._msgObj.HasHtml = false;
			this._msgObj.HasPlain = true;
		}
	},
	
	SetFromField: function (value)
	{
		this._fromField = value;
		this.ChangeFromAddr();
		this.Fill();
	},
	
	SetIdAccount: function (idAcct)
	{
		if (this._idAcct != idAcct) {
			this._idAcct = idAcct;
			GetHandler(TYPE_SIGNATURE, { IdAcct: this._idAcct }, [], '');
		}
	},
	
	UpdateMessageForReply: function (message, replyAction)
	{
		this._newMessage = false;
		Screens[SCREEN_NEW_MESSAGE].ShowHandler = '';
		this._msgObj = new CMessage();
		this._msgObj.PrepareForReply(message, replyAction, this._fromField);
		this._msgObj.FromAddr = this._fromField;
		this._messageLoaded = true;
		this._signatureLoaded = true;
		this.Fill();
	},
	
	UpdateMessageFromContacts: function (toField)
	{
		Screens[SCREEN_NEW_MESSAGE].ShowHandler = '';
		this.SetNewMessage();
		this._msgObj.ToAddr = toField;
		this._messageLoaded = true;
		this.Fill();
	},

	UpdateMessage: function (message)
	{
		this._newMessage = false;
		Screens[SCREEN_NEW_MESSAGE].ShowHandler = '';
		this._msgObj = new CMessage();
		this._msgObj.PrepareForEditing(message);
		this._messageLoaded = true;
		this._signatureLoaded = true;
		this.Fill();
	},
	
	SetMessageLoaded: function ()
	{
		Screens[SCREEN_NEW_MESSAGE].ShowHandler = '';
		this._messageLoaded = true;
	},

	ShowPictures: function ()
	{
		if (this._msgObj.Safety == 0)
		{
			this._msgObj.ShowPictures();
			if (this._msgObj.HasHtml) {
				HtmlEditorField.SetHtml(this._msgObj.HtmlBody);
			}
			else {
				HtmlEditorField.SetText(this._msgObj.PlainBody);
			}
			this.ResizeBody();
		}
	},

	Fill: function ()
	{
		if ((null != this._msgObj) && this.shown && this._messageLoaded && this._signatureLoaded) {
			var msg = this._msgObj;
			this.SetPriority(msg.Importance);
			
			if (msg.Safety != 0 || !this._allowDhtmlEditor) {
				this._picturesControl.Hide();
			}
			else {
				this._picturesControl.Show();
			}

			this._fromObj.value = msg.FromAddr;
			this._toObj.value = msg.ToAddr;
			this._ccObj.value = msg.CCAddr;
			this._bccObj.value = msg.BCCAddr;
			if (msg.BCCAddr.length == 0) {
				this._bccSwitcher.innerHTML = Lang.ShowBCC;
				this._hasBcc = false;
				this._bccCont.className = 'wm_hide';
			}
			else {
				this._bccSwitcher.innerHTML = Lang.HideBCC;
				this._hasBcc = true;
				this._bccCont.className = '';
			}
			this._subjectObj.value = msg.Subject;

			if (this._allowDhtmlEditor) {
				if (msg.HasHtml) {
					HtmlEditorField.SetHtml(HtmlDecodeBody(msg.HtmlBody));
					HtmlEditorField.Show(7);
					this._plainEditorObj.tabIndex = -1;
				}
				else {
					HtmlEditorField.SetText(HtmlDecodeBody(msg.PlainBody));
					this._plainEditorObj.tabIndex = 6;
				}
			}
			else {
				if (msg.HasPlain) {
					this._plainEditorObj.value = HtmlDecodeBody(msg.PlainBody);
				}
				else {
					this._plainEditorObj.value = HtmlDecode(HtmlDecodeBody(msg.HtmlBody).replace(/<br *\/{0,1}>/gi, '\n').replace(/<[^>]*>/g, ''));
				}
				this._plainEditorObj.tabIndex = 6;
			}
			this.EnableForm();
			this.RedrawAttachments(msg.Attachments);
			this.RebuildUploadForm();
			if (!msg.HasHtml || !this._allowDhtmlEditor) {
				this._plainEditorObj.focus();
				if (this._plainEditorObj.createTextRange)  
				{  
					var range = this._plainEditorObj.createTextRange();  
					range.collapse(true);  
					range.select();  
				}
				else {
					this._plainEditorObj.selectionStart = 0;
					this._plainEditorObj.selectionEnd = 0;
				}
			}
		}
		else if (this.shown) {
			this.ClearForm();
			this.DisableForm();
		}
		if (this.shown) this.ResizeBody();
	},//Fill
	
//mode = 0 - send message
//mode = 1 - save message
	SaveChanges: function (mode)
	{
		if (this._sending && mode == 0) return;
		if (this._saving && mode == 1) return;
		var fromValue = Trim(this._fromObj.value);
		if (mode == 0 && fromValue.length < 1) {
			alert(Lang.WarningFromBlank);
			return;
		}
		var toValue = this._toObj.value;
		var ccValue = this._ccObj.value;
		var bccValue = this._bccObj.value;
		if (mode == 0 && toValue.length < 1 && ccValue.length < 1 && bccValue.length < 1) {
			alert(Lang.WarningToBlank);
			return;
		}
		var subjectValue = this._subjectObj.value;
		var save_anyway = true;
		if (mode == 0 && subjectValue.length == 0) {
		    save_anyway = confirm(Lang.ConfirmEmptySubject);
		}
		if (save_anyway) {
			var newMsg = new CMessage();
			newMsg.FromAddr = this._fromObj.value;
			newMsg.ToAddr = toValue;
			newMsg.CCAddr = ccValue;
			if (this._hasBcc) newMsg.BCCAddr = this._bccObj.value;
			newMsg.Subject = subjectValue;
			newMsg.Importance = this._priority;
			
			if (this._allowDhtmlEditor && HtmlEditorField._htmlMode) {
				var value = HtmlEditorField.GetText();
				if (typeof(value) == 'string') {
					newMsg.HasHtml = true;
					newMsg.HtmlBody = value;
				}
			}
			else {
				newMsg.HasHtml = false;
				newMsg.PlainBody = this._plainEditorObj.value;
			}
			
			newMsg.Attachments = this._attachments;

			newMsg.Id = this._msgObj.Id;
			newMsg.Uid = this._msgObj.Uid;
			newMsg.SendersGroups = this._sendersGroups;

			var SEND_MODE = 0;
			var SAVE_MODE = 1;
			var xml = newMsg.GetInXML();
			switch (mode) {
			    case SEND_MODE:
			        RequestHandler('send', 'message', xml);
				    this._sending = true;
				    break;
				case SAVE_MODE:
				    RequestHandler('save', 'message', xml);
				    this._saving = true;
				    break;
			}
		}
	},//SaveChanges
	
	SwitchBccMode: function ()
	{
		if (this._hasBcc) {
			this._bccSwitcher.innerHTML = Lang.ShowBCC;
			this._hasBcc = false;
			this._bccCont.className = 'wm_hide';
		}
		else {
			this._bccSwitcher.innerHTML = Lang.HideBCC;
			this._hasBcc = true;
			this._bccCont.className = '';
		}
		if (Browser.Gecko) {
			this.ResizeBody();
		}
		else {
			HtmlEditorField.Replace();
		}
	},
	
	CreateDeleteAttachmentClick: function (index, obj)
	{
		return function () { obj.DeleteAttachment(index); return false; }
	},
	
	LoadAttachment: function (attachment)
	{
		var obj = this;
		var tbl = this._attachmentsTbl;
		var tr = tbl.insertRow(this._rowIndex);
		var td = tr.insertCell(0);
		td.className = 'wm_attachment';
		var params = GetFileParams(attachment.FileName);
		var img = CreateChildWithAttrs(td, 'img', [['src', 'images/icons/' + params.image]]);
		var span = CreateChild(td, 'span');
		span.innerHTML = attachment.FileName + '&nbsp;(' + GetFriendlySize(attachment.Size) + ')&nbsp;';
		var a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.onclick = this.CreateDeleteAttachmentClick(this._rowIndex, obj);
		a.innerHTML = Lang.Delete;
		this._attachments[this._rowIndex] = attachment;
		this._rowIndex++;
		this.RebuildUploadForm();
		if (Browser.Gecko) {
			this.ResizeBody();
		}
	},
	
	DeleteAttachment: function (index)
	{
		delete this._attachments[index];
		var attachs = this._attachments;
		this.RedrawAttachments(attachs);
		if (Browser.Gecko) {
			this.ResizeBody();
		}
	},
	
	RedrawAttachments: function (attachs)
	{
		CleanNode(this._attachmentsDiv);
		this._attachmentsTbl = CreateChild(this._attachmentsDiv, 'table');
		this._attachmentsTbl.className = 'wm_new_message';
		this._attachments = Array();
		this._rowIndex = 0;
		for (var i in attachs) {
			this.LoadAttachment(attachs[i]);
		}
	},
	
	ChangePriority: function ()
	{
		var pr = this._priority;
		switch (pr) {
			case PRIORITY_LOW: this.SetPriority(PRIORITY_NORMAL); break;
			case PRIORITY_NORMAL: this.SetPriority(PRIORITY_HIGH); break;
			case PRIORITY_HIGH: this.SetPriority(PRIORITY_LOW); break;
		}
	},
	
	SetPriority: function (pr)
	{
		switch (pr) {
			case PRIORITY_LOW:
				this._priority = PRIORITY_LOW;
				this._priorityLowButton.Show();
				this._priorityNormalButton.Hide();
				this._priorityHighButton.Hide();
			break;
			case PRIORITY_NORMAL:
				this._priority = PRIORITY_NORMAL;
				this._priorityLowButton.Hide();
				this._priorityNormalButton.Show();
				this._priorityHighButton.Hide();
			break;
			case PRIORITY_HIGH:
				this._priority = PRIORITY_HIGH;
				this._priorityLowButton.Hide();
				this._priorityNormalButton.Hide();
				this._priorityHighButton.Show();
			break;
			default:
				alert([pr, PRIORITY_LOW, PRIORITY_NORMAL, PRIORITY_HIGH]);
				break;
		}
	},
	
	BuildToolBar: function (container)
	{
		var obj = this;
		var toolBar = new CToolBar(container, this._skinName);
		var item = toolBar.AddItem(TOOLBAR_BACK_TO_LIST, function () {
			SetHistoryHandler(
				{
					ScreenId: WebMail.ListScreenId,
					FolderId: null
				}
			);
		}, true);
		item = toolBar.AddItem(TOOLBAR_SEND_MESSAGE, function () { obj.SaveChanges(0); }, true);
		item = toolBar.AddItem(TOOLBAR_SAVE_MESSAGE, function () { obj.SaveChanges(1); }, true);
		var changePriorFunc = function () { obj.ChangePriority(); };
		this._priorityLowButton = toolBar.AddItem(TOOLBAR_LOW_IMPORTANCE, changePriorFunc, false);
		this._priorityNormalButton = toolBar.AddItem(TOOLBAR_NORMAL_IMPORTANCE, changePriorFunc, false);
		this._priorityHighButton = toolBar.AddItem(TOOLBAR_HIGH_IMPORTANCE, changePriorFunc, false);
		toolBar.AddLastItem();
		toolBar.Hide();
		this._toolBar = toolBar;
	},

	RebuildUploadForm: function ()
	{
		var form = this._uploadForm;
		CleanNode(form);
		var span = CreateChild(form, 'span');
		span.innerHTML = Lang.AttachFile + ':&nbsp;';
		var inp = CreateChildWithAttrs(form, 'input', [['type', 'file'], ['class', 'wm_file'], ['name', 'fileupload']]);
		this._uploadFile = inp;
		span = CreateChild(form, 'span');
		span.innerHTML = '&nbsp;';
		inp = CreateChildWithAttrs(form, 'input', [['type', 'submit'], ['class', 'wm_button'], ['value', Lang.Attach]]);
	},
	
	Build: function (container, accountsBar, popupMenus, settings)
	{
		var obj = this;
		this._showTextLabels = settings.ShowTextLabels;
		this._allowDhtmlEditor = settings.AllowDhtmlEditor;

		this._logo = document.getElementById('logo');
		this._accountsBar = accountsBar;

		this.BuildToolBar(container);
		
		this._mainContainer = CreateChild(container, 'div');
		this._mainContainer.className = 'wm_hide';

		this._showPicturesTbl = this._picturesControl.Build(this._mainContainer);
		var tbl = CreateChild(this._mainContainer, 'table');
		this._headersTbl = tbl;
		tbl.className = 'wm_new_message';
		var RowIndex = 0;
		
		

		tr = tbl.insertRow(RowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_new_message_title';
		td.innerHTML = Lang.From + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'From', ':');
		td = tr.insertCell(1);
		var inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '93'], ['maxlength', '255']]);
		inp.tabIndex = 1;
		this._fromObj = inp;
		
		tr = tbl.insertRow(RowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_new_message_title';
		var a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
        CreateTextChild(a, Lang.To);
        CreateTextChild(td, ':');
		WebMail.LangChanger.Register('innerHTML', td, 'To', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '93']]);
		inp.tabIndex = 2;
		inp.onfocus = function () {
			obj.AutoFilling.SetSuggestInput(this);
		};
		this._toObj = inp;
		a.onclick = function () {
		    obj.PopupContacts.ControlClick(obj._toObj, this);
		    return false;
		};
		
		tr = tbl.insertRow(RowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_new_message_title';
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
        CreateTextChild(a, Lang.CC);
        CreateTextChild(td, ':');
		WebMail.LangChanger.Register('innerHTML', td, 'CC', ':');
		td = tr.insertCell(1);
		nobr = CreateChild(td, 'nobr');
		inp = CreateChildWithAttrs(nobr, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '93']]);
		inp.tabIndex = 3;
		inp.onfocus = function () {
			obj.AutoFilling.SetSuggestInput(this);
		};
		this._ccObj = inp;
		a.onclick = function () {
		    obj.PopupContacts.ControlClick(obj._ccObj, this);
		    return false;
		};

		var span = CreateChild(nobr, 'span');
		span.innerHTML = '&nbsp;';
		a = CreateChildWithAttrs(nobr, 'a', [['href', '#']]);
		a.onclick = function () { obj.SwitchBccMode(); return false; };
		a.innerHTML = Lang.ShowBCC;
		WebMail.LangChanger.Register('innerHTML', a, 'ShowBCC', '');
		a.tabIndex = -1;
		this._bccSwitcher = a;
		this._hasBcc = false;

		tr = tbl.insertRow(RowIndex++);
		tr.className = 'wm_hide';
		td = tr.insertCell(0);
		td.className = 'wm_new_message_title';
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
        CreateTextChild(a, Lang.BCC);
        CreateTextChild(td, ':');
		WebMail.LangChanger.Register('innerHTML', td, 'BCC', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '93']]);
		inp.tabIndex = 4;
		inp.onfocus = function () {
			obj.AutoFilling.SetSuggestInput(this);
		};
		this._bccObj = inp;
		this._bccCont = tr;
		a.onclick = function () {
		    obj.PopupContacts.ControlClick(obj._bccObj, this);
		    return false;
		};

		tr = tbl.insertRow(RowIndex++);
		td = tr.insertCell(0);
		td.className = 'wm_new_message_title';
		td.innerHTML = Lang.Subject + ':';
		WebMail.LangChanger.Register('innerHTML', td, 'Subject', ':');
		td = tr.insertCell(1);
		inp = CreateChildWithAttrs(td, 'input', [['type', 'text'], ['class', 'wm_input'], ['size', '93'], ['maxlength', '255']]);
		inp.tabIndex = 5;
		inp.onfocus = function () {
			obj.AutoFilling.Hide();
		};
		this._subjectObj = inp;

		tr = tbl.insertRow(RowIndex++);
		td = tr.insertCell(0);
		td.colSpan = 2;
		var div = CreateChild(td, 'div');
		div.className = 'wm_input wm_plain_editor_container';
		var txt = CreateChild(div, 'textarea');
		txt.className = 'wm_plain_editor_text';
		txt.tabIndex = 6;
		this._plainEditorObj = txt;
		this._plainEditorDiv = div;
		this._plainEditorCont = td;

		tr = tbl.insertRow(RowIndex++);
		td = tr.insertCell(0);
		td = tr.insertCell(1);
		td.className = 'wm_html_editor_switcher';
		a = CreateChildWithAttrs(td, 'a', [['href', '#']]);
		a.innerHTML = Lang.SwitchToPlainMode;
		this._modeSwitcher = a;
		this._modeSwitcherCont = tr;

		div = CreateChild(this._mainContainer, 'div');
		with (div.style) {
			margin = '0px';
			padding = '0px';
		}
		this._attachmentsDiv = div;
		tbl = CreateChild(div, 'table');
		tbl.className = 'wm_new_message';
		this._attachmentsTbl = tbl;

		tbl = CreateChild(this._mainContainer, 'table');
		tbl.className = 'wm_new_message';
		tr = tbl.insertRow(0);
		td = tr.insertCell(0);
		td.className = 'wm_attach';
		var uploadFrame = CreateChildWithAttrs(td, 'iframe', [['src', EmptyHtmlUrl], ['name', 'UploadFrame'], ['id', 'UploadFrame'], ['class', 'wm_hide']]);
		this._uploadForm = CreateChildWithAttrs(td, 'form', [['action', UploadUrl], ['method', 'post'], ['enctype', 'multipart/form-data'], ['target', 'UploadFrame'], ['id', 'UploadForm']]);
		this.RebuildUploadForm();
		var obj = this;
		this._uploadForm.onsubmit = function () {
			if (obj._uploadFile.value.length == 0) return false;
		};
		this._uploadTbl = tbl;

        this.PopupContacts = new CPopupContacts(GetAutoFillingContactsHandler, SelectSuggestionHandler);
		this.AutoFilling = new CPopupAutoFilling(GetAutoFillingContactsHandler, SelectSuggestionHandler);

		this.isBuilded = true;
	}//Build
};

